;#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
;#AutoIt3Wrapper_Icon=EM-Iconbig2.ico
;#AutoIt3Wrapper_Outfile=Em_Tool.exe
;#AutoIt3Wrapper_Compression=4
;#AutoIt3Wrapper_Res_Fileversion=2.0.8.0
;#AutoIt3Wrapper_Res_Fileversion_AutoIncrement=p
;#AutoIt3Wrapper_Res_requestedExecutionLevel=asInvoker
;#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#pragma compile(Icon,EM-Iconbig2.ico)
#pragma compile(Out,Em_Tool.exe)
#pragma compile(Compression,9)
#pragma compile(FileVersion,2.0.9)
#pragma compile(ExecLevel,asInvoker)
#cs ----------------------------------------------------------------------------
EM Tool 2.08 - Evochron Mercenary Tool.
Copyright (c) 2012 by Archibald H. Vilanos III
AutoIt Version: 3.3.8.1

#ce ----------------------------------------------------------------------------
#include <GUIConstantsEx.au3>
#include <File.au3>
#include <WindowsConstants.au3>
#include <String.au3>
#include <Array.au3>
#include <WinAPI.au3>
#include <StaticConstants.au3>
#include <ButtonConstants.au3>
#include <EditConstants.au3>
#include <Date.au3>
#include <GuiEdit.au3>
#include <ScrollBarConstants.au3>
#include <misc.au3>			;for _TipDisplayLen()
;#include <Archy.au3>

Global $maxzoom = 13

Dim $scripttitle, $version, $msg, $savedatafile, $handle, $delay, $configfile, $datafile, $dataarray[111], $datacheck[111], $graphic, $usesound, $blink, $array[1]
Dim $maplist[10000], $objectlist[10000], $zoomfactor[$maxzoom+1][4], $cb[6], $sectorslabel[9], $notes[1], $rates[11][3], $ranks[11][3], $log[1], $fuel[2]


Global $sectors[1]
Global $sectorssx[1]
Global $sectorssy[1]
Global $sectorssz[1]
Global $sectorzoom1[1]
Global $sectorzoom2[1]
Global $sectorzoom3[1]
Global $sectorzoom4[1]
Global $sectorzoom5[1]
Global $sectorzoom6[1]
Global $sectorzoom7[1]
Global $maplabels[1], $mapnames[1], $mapcoords[1]
Global $objects[1]
Global $objectssx[1]
Global $objectssy[1]
Global $objectssz[1]
Global $objectsx[1]
Global $objectsy[1]
Global $objectsz[1]
Global $objectslabel[1]
Global $objectstype[1]
Global $objectlabels[1], $objectnames[1], $objectcoords[1], $objectscoords[1]
Global $gopntr, $pntr
Global $sectorcount
Global $objectcount
Global $hUser32Dll = DllOpen("user32.dll")
Global $MapDblClkFlg = 0


$scripttitle = "EM Tool"
$version = "2.09" ;& Chrw(0x03b2)
$usesound = TRUE
$wavs = True
$updatemap = True
$minfuel = 25
$usekeys = True
$targetchanged = FALSE
$gox = 0
$goz = 0
$go = False
$wasgo = False
$lastoffsetx = 0
$lastoffsetz = 0
$windowx = 1000
$windowz = 700

$rates[1][1] = 24
$rates[1][2] = "Rookie"
$rates[2][1] = 99
$rates[2][2] = "Novice"
$rates[3][1] = 499
$rates[3][2] = "Competent"
$rates[4][1] = 999
$rates[4][2] = "Skilled"
$rates[5][1] = 1999
$rates[5][2] = "Advanced"
$rates[6][1] = 2999
$rates[6][2] = "Expert"
$rates[7][1] = 4999
$rates[7][2] = "Master"
$rates[8][1] = 7499
$rates[8][2] = "Superior"
$rates[9][1] = 9998
$rates[9][2] = "Veteren"
$rates[10][1] = 0
$rates[10][2] = "Legend"

$ranks[1][1] = 4
$ranks[1][2] = "Trainee"
$ranks[2][1] = 24
$ranks[2][2] = "Ensign"
$ranks[3][1] = 49
$ranks[3][2] = "Lt Jr G"
$ranks[4][1] = 99
$ranks[4][2] = "Lt"
$ranks[5][1] = 149
$ranks[5][2] = "Lt Commander"
$ranks[6][1] = 249
$ranks[6][2] = "Commander"
$ranks[7][1] = 499
$ranks[7][2] = "Captain"
$ranks[8][1] = 749
$ranks[8][2] = "Commodore"
$ranks[9][1] = 998
$ranks[9][2] = "Admiral"
$ranks[10][1] = 0
$ranks[10][2] = "Flt Admiral"

$thisnotefile = "this"
$currentnotefile = "that"

If WinExists("EM Tool v" & $version) Then
	WinActivate("EM Tool v" & $version)
	Exit
EndIf

FileInstall("Em_Tool.gif", "EM_Tool.gif")
FileInstall("Em_Tool.txt", "EM_Tool.txt")
FileInstall("Em_Tool2.txt", "EM_Tool2.txt")
FileInstall("Em_Tool_Fuel.wav", "EM_Tool_Fuel.wav")
FileInstall("Em_Tool_Hostile.wav", "EM_Tool_Hostile.wav")
FileInstall("EM_Tool_Buttonf.bmp", "EM_Tool_Buttonf.bmp")
FileInstall("EM_Tool_Buttonf_on.bmp", "EM_Tool_Buttonf_on.bmp")
FileInstall("EM_Tool_Buttonl.bmp", "EM_Tool_Buttonl.bmp")
FileInstall("EM_Tool_Buttonr.bmp", "EM_Tool_Buttonr.bmp")
FileInstall("EM_Tool_Buttonu.bmp", "EM_Tool_Buttonu.bmp")
FileInstall("EM_Tool_Buttond.bmp", "EM_Tool_Buttond.bmp")
FileInstall("EM_Tool_Buttoni.bmp", "EM_Tool_Buttoni.bmp")
FileInstall("EM_Tool_Buttono.bmp", "EM_Tool_Buttono.bmp")
FileInstall("EM_Tool_Buttonx.bmp", "EM_Tool_Buttonx.bmp")
FileInstall("EM_Tool_Buttons.bmp", "EM_Tool_Buttons.bmp")
FileInstall("EM_Tool_Buttonn.bmp", "EM_Tool_Buttonn.bmp")
FileInstall("EM_Tool_Buttonn_note.bmp", "EM_Tool_Buttonn_note.bmp")
FileInstall("EM_Tool_Buttonlog.bmp", "EM_Tool_Buttonlog.bmp")
FileInstall("EM_Tool_Buttonlog_on.bmp", "EM_Tool_Buttonlog_on.bmp")

For $x = 1 to 100
	$datacheck[$x] = "!!!!!"
Next

$zoomfactor[1][1] = 8000
$zoomfactor[1][2] = 4000
$zoomfactor[1][3] = 40
$zoomfactor[2][1] = 4000
$zoomfactor[2][2] = 2000
$zoomfactor[2][3] = 20
$zoomfactor[3][1] = 3000
$zoomfactor[3][2] = 1500
$zoomfactor[3][3] = 15

$zoomfactor[4][1] = 2000
$zoomfactor[4][2] = 1000
$zoomfactor[4][3] = 10
$zoomfactor[5][1] = 1000
$zoomfactor[5][2] = 500
$zoomfactor[5][3] = 5

$zoomfactor[6][1] = 500
$zoomfactor[6][2] = 250
$zoomfactor[6][3] = 2.5

$zoomfactor[7][1] = 200
$zoomfactor[7][2] = 100
$zoomfactor[7][3] = 1

$zoomfactor[8][1] = 20
$zoomfactor[8][2] = 10
$zoomfactor[8][3] = 0.1
$zoomfactor[9][1] = 8
$zoomfactor[9][2] = 4
$zoomfactor[9][3] = 0.04
$zoomfactor[10][1] = 4
$zoomfactor[10][2] = 2
$zoomfactor[10][3] = 0.02
$zoomfactor[11][1] = 2
$zoomfactor[11][2] = 1
$zoomfactor[11][3] = 0.01
$zoomfactor[12][1] = 1
$zoomfactor[12][2] = 0.5
$zoomfactor[12][3] = 0.005
$zoomfactor[13][1] = 0.5
$zoomfactor[13][2] = 0.25
$zoomfactor[13][3] = 0.0025

$zoom = 2
$perspectivex = 0
$perspectivez = 0
$zoomed = False
$MAPCHLVL = 8
$HideNonSystemLabelsAbove = 9
$follow = True

$left1 = -1
$left2 = -1
$left3 = -1
$top1 = -1
$top2 = -1
$top3 = -1

If FileExists("EM_Tool.dat") Then
	$datfile = FileOpen("EM_Tool.dat")
	$left1 = FileReadLine($datfile)
	$top1 = FileReadLine($datfile)
	$left2 = FileReadLine($datfile)
	$top2 = FileReadLine($datfile)
	$left3 = FileReadLine($datfile)
	$top3 = FileReadLine($datfile)
	FileClose($datfile)
EndIf

$handle = GUICreate($scripttitle & " v" & $version , $windowx, $windowz, $left1, $top1, BitOr($GUI_SS_DEFAULT_GUI, $WS_SIZEBOX, $WS_MAXIMIZEBOX, $WS_EX_LAYERED))
GUISetBkColor(0x000000, $handle)
GUISetState(@SW_SHOW, $handle)


If FileExists("EM_Tool.cfg") Then
	$configfile = FileOpen ("EM_Tool.cfg" , 0)
	If $configfile = -1 Then
		MsgBox(16, "ERROR", "Could not open EM_Tool.cfg")
		Exit
	EndIf
	$savedatafile = FileReadLine($configfile)
	$delay = FileReadLine($configfile)
	$temp = FileReadLine($configfile)
	If $temp <> "SOUND=ON" Then
		$usesound = False
	EndIf
	$temp = FileReadLine($configfile)
	If $temp <> "USEWAVS=ON" Then
		$wavs = False
	EndIf
	$temp = FileReadLine($configfile)
	If $temp <> "UPDATEMAP=ON" Then
		$updatemap = False
	EndIf
	$temp = FileReadLine($configfile)
	If StringLeft($temp, 8) <> "MINFUEL=" Then
		$minfuel = 25
	Else
		$array = _StringBetween($temp, "MINFUEL=", "")
		$temp = $array[0]
		$temp = StringStripWS($temp, 8)
		$isnum = StringIsDigit($temp)
		If $isnum = 1 Then
			If $temp > 0 and $temp <= 100 Then
				$minfuel = $temp
			EndIf
		EndIf
	EndIf
	$temp = FileReadLine($configfile)
	If $temp <> "USEKEYS=ON" Then
		$usekeys = False
	EndIf
	$temp = FileReadLine($configfile)
	If StringLeft($temp, 15) <> "EMTool2ZoomLvl=" Then
		$MAPCHLVL = 8
	Else
		$array = _StringBetween($temp, "EMTool2ZoomLvl=", "")
		$temp = $array[0]
		$temp = StringStripWS($temp, 8)
		$isnum = StringIsDigit($temp)
		If $isnum = 1 Then
			If $temp > 0 and $temp <= $maxzoom Then
				$MAPCHLVL = $temp
			EndIf
		EndIf
	EndIf
	$temp = FileReadLine($configfile)
	If StringLeft($temp, 34) <> "EMTool2HideNonSystemLabelsZoomLvl=" Then
		$HideNonSystemLabelsAbove = 9
	Else
		$array = _StringBetween($temp, "EMTool2HideNonSystemLabelsZoomLvl=", "")
		$temp = $array[0]
		$temp = StringStripWS($temp, 8)
		$isnum = StringIsDigit($temp)
		If $isnum = 1 Then
			If $temp > 0 and $temp <= $maxzoom Then
				$HideNonSystemLabelsAbove = $temp
			EndIf
		EndIf
	EndIf
	FileClose($configfile)
	If $delay < 250 Then $delay = 250
Else
	$savedatafile = "savedata.txt"
	$delay = 2000
	$configfile = FileOpen ("EM_Tool.cfg" , 2)
	If $configfile = -1 Then
		MsgBox(16, "ERROR", "Could not create EM_Tool.cfg")
		Exit
	EndIf
	FileWriteLine($configfile, $savedatafile)
	FileWriteLine($configfile, $delay)
	FileWriteLine($configfile, "SOUND=ON")
	FileWriteLine($configfile, "USEWAVS=OFF")
	FileWriteLine($configfile, "UPDATEMAP=ON")
	FileWriteLine($configfile, "MINFUEL=25")
	FileWriteLine($configfile, "USEKEYS=ON")
	FileWriteLine($configfile, "EMTool2ZoomLvl=8")
	FileWriteLine($configfile, "EMTool2HideNonSystemLabelsZoomLvl=9")
	FileClose($configfile)
EndIf

$map = GUICtrlCreatePic ("EM_Tool.gif", 0, 0, $windowx, $windowz)
GUICtrlSetResizing ($map, $GUI_DOCKAUTO)
GuiCtrlSetState($map, $GUI_DISABLE)

GUISetFont (8, 400, 0, "Arial")
$hcurrentmapx = GUICtrlCreateLabel("0", 470, 121, 60,10, $SS_CENTER)
GUICtrlSetColor ($hcurrentmapx, "0x000000")
GUICtrlSetBkColor ($hcurrentmapx, $GUI_BKCOLOR_TRANSPARENT)
$hcurrentmapz = GUICtrlCreateLabel("0", 273, 304, 8, 100, $SS_CENTER)
GUICtrlSetColor ($hcurrentmapz, "0x000000")
GUICtrlSetBkColor ($hcurrentmapz, $GUI_BKCOLOR_TRANSPARENT)
$hscale1 = GUICtrlCreateLabel(ChrW(0x2502) & ChrW(0x2190), 449, 567, 20, 10)
GUICtrlSetColor ($hscale1, "0x000000")
GUICtrlSetBkColor ($hscale1, $GUI_BKCOLOR_TRANSPARENT)
$hscale2 = GUICtrlCreateLabel(ChrW(0x2192) & ChrW(0x2502), 539, 567, 20, 10)
GUICtrlSetColor ($hscale2, "0x000000")
GUICtrlSetBkColor ($hscale2, $GUI_BKCOLOR_TRANSPARENT)
$hscale = GUICtrlCreateLabel("2000", 481, 566, 40, 10, $SS_CENTER)
GUICtrlSetColor ($hscale, "0x000000")
GUICtrlSetBkColor ($hscale, $GUI_BKCOLOR_TRANSPARENT)

LoadMap(False)

GUICtrlSetDefBkColor($GUI_BKCOLOR_TRANSPARENT)
$displayedmap = False
$begin = TimerInit()
GUISetFont ( 12, 400, 0, "Arial")
$nosave = FALSE
$waiting = GUICtrlCreateLabel("Waiting for savedata.txt file... "    , 400, 250, 300)
GUICtrlSetColor ($waiting, "0xFFFFFF")
While $nosave = FALSE
	$msg = GUIGetMsg()
	If $msg = $GUI_EVENT_CLOSE Then Exit
	$nosave = FileExists($savedatafile)
WEnd
$dots = 0
GUICtrlSetColor ($waiting, "0x000000")
GUICtrlSetData($waiting, "")
GUICtrlSetState ($waiting, $GUI_HIDE)

If _FileReadToArray($savedatafile, $dataarray) Then
	For $x = 1 to $dataarray[0]
		If $dataarray[$x] = "" Then
			$dataarray[$x] = " "
		EndIf
	Next
	GUISetFont ( 10, 400, 0, "Arial")
	;rank
	$hrank = GUICtrlCreateLabel("", 35, 38, 90, 20, $SS_RIGHT)
	GUICtrlSetColor ($hrank, "0xFFFF00")
	;rating
	$hrate = GUICtrlCreateLabel("", 255, 38, 75, 20, $SS_LEFT)
	GUICtrlSetColor ($hrate, "0xFFFF00")

	GUISetFont ( 12, 400, 0, "Arial")
	;Pilot
	$p1 = GUICtrlCreateLabel($dataarray[1], 125, 35, 130, 20, $SS_CENTER)
	GUICtrlSetColor ($P1, "0xFFFFFF")
	;Cash
	$p3 = GUICtrlCreateLabel($dataarray[3], 110, 62, 150, 20)
	GUICtrlSetColor ($P3, "0xFFFFFF")
	;Fuel
	$p2 = GUICtrlCreateLabel($dataarray[2], 110, 89, 150, 20)
	GUICtrlSetColor ($P2, "0xFFFFFF")
	;CMs
	$p81 = GUICtrlCreateLabel($dataarray[81], 110, 116, 150, 20)
	GUICtrlSetColor ($P81, "0xFFFFFF")
	;Cargo1
	$p4 = GUICtrlCreateLabel(Iif($dataarray[4] = "Empty", "", $dataarray[4]), 110, 143, 150, 20)
	GUICtrlSetColor ($P4, "0xFFFFFF")
	;Cargo2
	$p5 = GUICtrlCreateLabel(Iif($dataarray[5] = "Empty", "", $dataarray[5]), 110, 170, 150, 20)
	GUICtrlSetColor ($P5, "0xFFFFFF")
	;Cargo3
	$p6 = GUICtrlCreateLabel(Iif($dataarray[6] = "Empty", "", $dataarray[6]), 110, 197, 150, 20)
	GUICtrlSetColor ($P6, "0xFFFFFF")
	;Cargo4
	$p7 = GUICtrlCreateLabel(Iif($dataarray[7] = "Empty", "", $dataarray[7]), 110, 224, 150, 20)
	GUICtrlSetColor ($P7, "0xFFFFFF")
	;Cargo5
	$p8 = GUICtrlCreateLabel(Iif($dataarray[8] = "Empty", "", $dataarray[8]), 110, 251, 150, 20)
	GUICtrlSetColor ($P8, "0xFFFFFF")

	;Cargo blanks
	GUISetFont ( 10, 400, 0, "Arial Black")
	$cb[1] = GUICtrlCreateLabel("", 40, 146, 50, 18)
	$cb[2] = GUICtrlCreateLabel("", 40, 173, 50, 18)
	$cb[3] = GUICtrlCreateLabel("", 40, 200, 50, 18)
	$cb[4] = GUICtrlCreateLabel("", 40, 227, 50, 18)
	$cb[5] = GUICtrlCreateLabel("", 40, 254, 50, 18)
	For $x = 1 to 5
		;GUICtrlSetData($cb[$x], _StringRepeat(Chr(0x2588), 6))
		GUICtrlSetColor ($cb[$x], "0x000000")
		GUICtrlSetBkColor ($cb[$x], "0x000000")
		GUICtrlSetState ($cb[$x], $GUI_HIDE)
	Next
	GUISetFont ( 12, 400, 0, "Arial")
	;Kills
	$p68 = GUICtrlCreateLabel($dataarray[68], 810, 36, 150, 20)
	GUICtrlSetColor ($P68, "0xCCCCCC")
	;Cntrcts
	$p69 = GUICtrlCreateLabel($dataarray[69], 810, 90, 150, 20)
	GUICtrlSetColor ($P69, "0xCCCCCC")
	;Enemies
	$p94 = GUICtrlCreateLabel($dataarray[94], 810, 198, 150, 20)
	GUICtrlSetColor ($P94, "0xFFFFFF")

	;System
	$p15 = GUICtrlCreateLabel($dataarray[15], 426, 36, 154, 20, $SS_CENTER)
	GUICtrlSetColor ($P15, "0x00FFFF")
	;SX
	$p12 = GUICtrlCreateLabel($dataarray[12], 365, 65, 80, 20)
	GUICtrlSetColor ($P12, "0x00FFFF")
	;SY
	$p13 = GUICtrlCreateLabel($dataarray[13], 485, 65, 80, 20)
	GUICtrlSetColor ($P13, "0x00FFFF")
	;SZ
	$p14 = GUICtrlCreateLabel($dataarray[14], 605, 65, 80, 20)
	GUICtrlSetColor ($P14, "0x00FFFF")
	;X
	$p9 = GUICtrlCreateLabel($dataarray[9], 365, 92, 80, 20)
	GUICtrlSetColor ($P9, "0x00FFFF")
	;Y
	$p10 = GUICtrlCreateLabel($dataarray[10], 485, 92, 80, 20)
	GUICtrlSetColor ($P10, "0x00FFFF")
	;Z
	$p11 = GUICtrlCreateLabel($dataarray[11], 605, 92, 80, 20)
	GUICtrlSetColor ($P11, "0x00FFFF")

	;Energy
	$p16 = GUICtrlCreateLabel($dataarray[16] & "%", 87, 295, 60, 20)
	GUICtrlSetColor ($P16, "0xFFFFFF")
	;Hull
	$p21 = GUICtrlCreateLabel($dataarray[21] & "%", 87, 318, 60, 20)
	GUICtrlSetColor ($P21, "0xFFFFFF")
	;Engine
	$p22 = GUICtrlCreateLabel($dataarray[22] & "%", 87, 342, 60, 20)
	GUICtrlSetColor ($P22, "0xFFFFFF")
	;Weapon
	$p23 = GUICtrlCreateLabel($dataarray[23] & "%", 87, 365, 60, 20)
	GUICtrlSetColor ($P23, "0xFFFFFF")
	;Nav
	$p24 = GUICtrlCreateLabel($dataarray[24] & "%", 87, 390, 60, 20)
	GUICtrlSetColor ($P24, "0xFFFFFF")

	;Power
	$p82 = GUICtrlCreateLabel($dataarray[82], 810, 144, 150, 20)
	GUICtrlSetColor ($P82, "0xFFFFFF")
	;Rank
	$p71 = GUICtrlCreateLabel($dataarray[71], 810, 63, 150, 20)
	GUICtrlSetColor ($P71, "0xCCCCCC")
	;Rating
	$p70 = GUICtrlCreateLabel($dataarray[70], 810, 117, 150, 20)
	GUICtrlSetColor ($P70, "0xCCCCCC")
	;Scan
	$p40 = GUICtrlCreateLabel("", 796, 545, 155, 20)
	GUICtrlSetColor ($P40, "0xFF0000")

	;Front
	$p17 = GUICtrlCreateLabel($dataarray[17] & "%", 87, 435, 60, 20)
	GUICtrlSetColor ($P17, "0xFFFFFF")
	;Rear
	$p20 = GUICtrlCreateLabel($dataarray[20] & "%", 87, 460, 60, 20)
	GUICtrlSetColor ($P20, "0xFFFFFF")
	;Left
	$p19 = GUICtrlCreateLabel($dataarray[19] & "%", 87, 483, 60, 20)
	GUICtrlSetColor ($P19, "0xFFFFFF")
	;Right
	$p18 = GUICtrlCreateLabel($dataarray[18] & "%", 87, 507, 60, 20)
	GUICtrlSetColor ($P18, "0xFFFFFF")

	$p78 = GUICtrlCreateLabel("!!! HEAT !!!", 105, 545, 100, 20)
	GUICtrlSetColor ($P78, "0x000000")

	;Target
	$p25 = GUICtrlCreateLabel($dataarray[25], 810, 225, 150, 20)
	GUICtrlSetColor ($P25, "0xFFFFFF")
	;Faction
	$p75 = GUICtrlCreateLabel($dataarray[75], 810, 252, 150, 20)
	GUICtrlSetColor ($P75, "0xFFFFFF")
	;Range
	$p27 = GUICtrlCreateLabel($dataarray[27], 810, 279, 150, 20)
	GUICtrlSetColor ($P27, "0xFFFFFF")
	;Hull
	$p76 = GUICtrlCreateLabel($dataarray[76] & "%", 796, 320, 60, 20)
	GUICtrlSetColor ($P76, "0xFFFFFF")
	;Front
	$p28 = GUICtrlCreateLabel($dataarray[28] & "%", 796, 435, 60, 20)
	GUICtrlSetColor ($P28, "0xFFFFFF")
	;Rear
	$p31 = GUICtrlCreateLabel($dataarray[31] & "%", 796, 460, 60, 20)
	GUICtrlSetColor ($P31, "0xFFFFFF")
	;Left
	$p30 = GUICtrlCreateLabel($dataarray[30] & "%", 796, 483, 60, 20)
	GUICtrlSetColor ($P30, "0xFFFFFF")
	;Right
	$p29 = GUICtrlCreateLabel($dataarray[29] & "%", 796, 507, 60, 20)
	GUICtrlSetColor ($P29, "0xFFFFFF")
	;Engine
	$p32 = GUICtrlCreateLabel($dataarray[32] & "%", 796, 344, 60, 20)
	GUICtrlSetColor ($P32, "0xFFFFFF")
	;Weapon
	$p33 = GUICtrlCreateLabel($dataarray[33] & "%", 796, 368, 60, 20)
	GUICtrlSetColor ($P33, "0xFFFFFF")
	;Nav
	$p34 = GUICtrlCreateLabel($dataarray[34] & "%", 796, 393, 60, 20)
	GUICtrlSetColor ($P34, "0xFFFFFF")
	;MDTS
	$p79 = GUICtrlCreateLabel("", 810, 171, 70, 20)
	GUICtrlSetColor ($P79, "0xFFFFFF")

	;Graphs
	GUISetFont (10, 400, 0, "Arial Black")
	$pbenergy = GUICtrlCreateLabel("", 151, 295, 100, 20) ;16
	GUICtrlSetColor ($pbenergy, "0x00FF00")
	$pbhull = GUICtrlCreateLabel("", 151, 319, 100, 20) ;21
	GUICtrlSetColor ($pbhull, "0x00FF00")
	$pbengine = GUICtrlCreateLabel("", 151, 343, 100, 20) ;22
	GUICtrlSetColor ($pbengine, "0x00FF00")
	$pbweap = GUICtrlCreateLabel("", 151, 367, 100, 20) ;23
	GUICtrlSetColor ($pbweap, "0x00FF00")
	$pbnav = GUICtrlCreateLabel("", 151, 391, 100, 20) ;24
	GUICtrlSetColor ($pbnav, "0x00FF00")

	$pbfront = GUICtrlCreateLabel("", 151, 434, 100, 20) ;17
	GUICtrlSetColor ($pbfront, "0x00FF00")
	$pbrear = GUICtrlCreateLabel("", 151, 458, 100, 20) ;20
	GUICtrlSetColor ($pbrear, "0x00FF00")
	$pbleft = GUICtrlCreateLabel("", 151, 482, 100, 20) ;19
	GUICtrlSetColor ($pbleft, "0x00FF00")
	$pbright = GUICtrlCreateLabel("", 151, 506, 100, 20) ;18
	GUICtrlSetColor ($pbright, "0x00FF00")

	$pbthull = GUICtrlCreateLabel("", 861, 319, 100, 20) ;76
	GUICtrlSetColor ($pbthull, "0x00FF00")
	$pbtengine = GUICtrlCreateLabel("", 861, 343, 100, 20) ;32
	GUICtrlSetColor ($pbtengine, "0x00FF00")
	$pbtweap = GUICtrlCreateLabel("", 861, 367, 100, 20) ;33
	GUICtrlSetColor ($pbtweap, "0x00FF00")
	$pbtnav = GUICtrlCreateLabel("", 861, 391, 100, 20) ;34
	GUICtrlSetColor ($pbtnav, "0x00FF00")

	$pbtfront = GUICtrlCreateLabel("", 861, 434, 100, 20) ;28
	GUICtrlSetColor ($pbtfront, "0x00FF00")
	$pbtrear = GUICtrlCreateLabel("", 861, 458, 100, 20) ;31
	GUICtrlSetColor ($pbtrear, "0x00FF00")
	$pbtleft = GUICtrlCreateLabel("", 861, 482, 100, 20) ;30
	GUICtrlSetColor ($pbtleft, "0x00FF00")
	$pbtright = GUICtrlCreateLabel("", 861, 506, 100, 20) ;29
	GUICtrlSetColor ($pbtright, "0x00FF00")

	GUISetFont ( 12, 400, 0, "Arial")
	$p51 = GUICtrlCreateLabel(Iif($dataarray[51] = "Empty", "", $dataarray[51]), 35, 587, 220, 20, $SS_CENTER)
	GUICtrlSetColor ($P51, "0xCCCCCC")
	$p52 = GUICtrlCreateLabel(Iif($dataarray[52] = "Empty", "", $dataarray[52]), 270, 587, 220, 20, $SS_CENTER)
	GUICtrlSetColor ($P52, "0xCCCCCC")
	$p53 = GUICtrlCreateLabel(Iif($dataarray[53] = "Empty", "", $dataarray[53]), 505, 587, 220, 20, $SS_CENTER)
	GUICtrlSetColor ($P53, "0xCCCCCC")
	$p54 = GUICtrlCreateLabel(Iif($dataarray[54] = "Empty", "", $dataarray[54]), 740, 587, 220, 20, $SS_CENTER)
	GUICtrlSetColor ($P54, "0xCCCCCC")
	$p55 = GUICtrlCreateLabel(Iif($dataarray[55] = "Empty", "", $dataarray[55]), 35, 614, 220, 20, $SS_CENTER)
	GUICtrlSetColor ($P55, "0xCCCCCC")
	$p56 = GUICtrlCreateLabel(Iif($dataarray[56] = "Empty", "", $dataarray[56]), 270, 614, 220, 20, $SS_CENTER)
	GUICtrlSetColor ($P56, "0xCCCCCC")
	$p57 = GUICtrlCreateLabel(Iif($dataarray[57] = "Empty", "", $dataarray[57]), 505, 614, 220, 20, $SS_CENTER)
	GUICtrlSetColor ($P57, "0xCCCCCC")
	$p58 = GUICtrlCreateLabel(Iif($dataarray[58] = "Empty", "", $dataarray[58]), 740, 614, 220, 20, $SS_CENTER)
	GUICtrlSetColor ($P58, "0xCCCCCC")


EndIf

$hsearch = GUICtrlCreateButton("", 165, 654, 20, 20, $BS_BITMAP)
GUICtrlSetImage ($hsearch, "EM_Tool_Buttons.bmp")

$hfollow = GUICtrlCreateButton("", 345, 654, 20, 20, $BS_BITMAP)
GUICtrlSetImage ($hfollow, "EM_Tool_Buttonf_on.bmp")

$hpanleft = GUICtrlCreateButton("", 385, 654, 20, 20, $BS_BITMAP)
GUICtrlSetImage ($hpanleft, "EM_Tool_Buttonl.bmp")

$hpanright = GUICtrlCreateButton("", 425, 654, 20, 20, $BS_BITMAP)
GUICtrlSetImage ($hpanright, "EM_Tool_Buttonr.bmp")

$hpanup = GUICtrlCreateButton("", 465, 654, 20, 20, $BS_BITMAP)
GUICtrlSetImage ($hpanup, "EM_Tool_Buttonu.bmp")

$hpandown = GUICtrlCreateButton("", 505, 654, 20, 20, $BS_BITMAP)
GUICtrlSetImage ($hpandown, "EM_Tool_Buttond.bmp")

$hzoomout = GUICtrlCreateButton("", 545, 654, 20, 20, $BS_BITMAP)
GUICtrlSetImage ($hzoomout, "EM_Tool_Buttono.bmp")

$hzoomin = GUICtrlCreateButton("", 585, 654, 20, 20, $BS_BITMAP)
GUICtrlSetImage ($hzoomin, "EM_Tool_Buttoni.bmp")

GUISetFont ( 8, 400, 0, "Arial")
$hzoom = GUICtrlCreateLabel($zoom, 571, 657, 10, 10, $SS_CENTER)
GUICtrlSetColor ($hzoom, "0x000000")


$hgoto = GUICtrlCreateButton("", 745, 654, 20, 20, $BS_BITMAP)
GUICtrlSetImage ($hgoto, "EM_Tool_Buttonx.bmp")

$hnotebutton = GUICtrlCreateButton("", 785, 654, 20, 20, $BS_BITMAP)
GUICtrlSetImage ($hnotebutton, "EM_Tool_Buttonn.bmp")
$hlogbutton = GUICtrlCreateButton("", 815, 654, 20, 20, $BS_BITMAP)
GUICtrlSetImage ($hlogbutton, "EM_Tool_Buttonlog.bmp")

GUISetFont ( 10, 400, 0, "Arial")

$hinputs = GUICtrlCreateInput("", 195, 654, 140, 20)
GUICtrlSetLimit ($hinputs, 18)
GUICtrlSetResizing (-1, $GUI_DOCKAUTO)

$hinputx = GUICtrlCreateInput("", 613, 654, 60, 20)
GUICtrlSetLimit ($hinputx, 7)
GUICtrlSetResizing (-1, $GUI_DOCKAUTO)
$hinputz = GUICtrlCreateInput("", 677, 654, 60, 20)
GUICtrlSetLimit ($hinputz, 7)
GUICtrlSetResizing (-1, $GUI_DOCKAUTO)

$soundcheck = GUICtrlCreateCheckbox ("", 980, 685, 12, 12)
GUICtrlSetColor ($soundcheck, "0x00FF00")
GUICtrlSetResizing (-1, $GUI_DOCKBOTTOM + $GUI_DOCKRIGHT + $GUI_DOCKSIZE)
If $usesound = TRUE Then GUICtrlSetState ($soundcheck, $GUI_CHECKED)

$alert = TimerInit()
$fuelalert = TimerInit()
GUISetFont (10, 600, 0, "Arial")
$snd = GUICtrlCreateLabel("Sound"    , 930, 683, 48)
GUICtrlSetColor ($snd, "0x000000")
GUICtrlSetResizing (-1, $GUI_DOCKBOTTOM + $GUI_DOCKRIGHT + $GUI_DOCKSIZE)

GUISetFont ( 8, 600, 0, "Arial")
$by = GUICtrlCreateLabel(" by Archibald H. Vilanos III "    , 10, 685, 160)
GUICtrlSetColor ($by, "0x000000")
GUICtrlSetResizing (-1, $GUI_DOCKBOTTOM + $GUI_DOCKLEFT + $GUI_DOCKSIZE)

$hreload = GUICtrlCreateButton("RELOAD", 930, 660, 56, 19)
GUICtrlSetBkColor ($hreload, "0x888888")
GUICtrlSetColor ($hreload, "0x000000")
GUICtrlSetResizing (-1, $GUI_DOCKBOTTOM + $GUI_DOCKRIGHT + $GUI_DOCKSIZE)

$windowchanged = True

;$tooltipbegin = -1

If $usekeys = True Then
	SetHotKeys()
EndIf

$starttime = _NowCalc()
$lasttimediff = 0

GUISetFont ( 12, 400, 0, "Arial")
$htimeonline = GUICtrlCreateLabel("0:00:00", 40, 645, 120)
GUICtrlSetColor ($htimeonline, "0x000000")
$lastnotefile = ""
$noteexists = False
$notesopen = False
$thisnotefile = ""
$logopen = False
$lastlog = ""

$hnoteswindow = GUICreate("EM Tool Sector Notes", 320, 250, $left2, $top2, BitOr($WS_POPUP, $WS_THICKFRAME))
GUISetState(@SW_HIDE, $hnoteswindow)
GUISetFont ( 10, 400, 0, "Arial")
$hnotetitle = GUICtrlCreateLabel("", 0, 0, 320, 20, $SS_CENTER, $GUI_WS_EX_PARENTDRAG)
GUICtrlSetColor ($hnotetitle, "0x000000")
GUICtrlSetBkColor ($hnotetitle, "0xCCCCCC")
GUICtrlSetResizing (-1, $GUI_DOCKTOP + $GUI_DOCKHEIGHT)
$hnotewarn = GUICtrlCreateLabel("", 0, 19, 320, 20, $SS_CENTER, $GUI_WS_EX_PARENTDRAG)
GUICtrlSetColor ($hnotewarn, "0xFF0000")
GUICtrlSetBkColor ($hnotewarn, "0xCCCCCC")
GUICtrlSetResizing (-1, $GUI_DOCKTOP + $GUI_DOCKHEIGHT)

GUISetFont (9, 400, 0, "Arial")
$hedit = GUICtrlCreateEdit("" & @CR, 0, 40, 320, 170, BitOr($WS_VSCROLL, $ES_AUTOVSCROLL, $ES_WANTRETURN))
GUICtrlSetState($hedit, $GUI_SHOW)
GUICtrlSetResizing (-1, $GUI_DOCKBOTTOM + $GUI_DOCKTOP)

GUISetFont (8, 600, 0, "Arial")
$hsave = GUICtrlCreateButton("SAVE", 40, 220, 60, 19)
GUICtrlSetBkColor ($hsave, "0xCCCCCC")
GUICtrlSetColor ($hsave, "0x000000")
GUICtrlSetResizing (-1, $GUI_DOCKBOTTOM + $GUI_DOCKSIZE)

$hcancel = GUICtrlCreateButton("CANCEL", 130, 220, 60, 19)
GUICtrlSetBkColor ($hcancel, "0xCCCCCC")
GUICtrlSetColor ($hcancel, "0x000000")
GUICtrlSetResizing (-1, $GUI_DOCKBOTTOM + $GUI_DOCKSIZE)

$hdelete = GUICtrlCreateButton("DELETE", 220, 220, 60, 19)
GUICtrlSetBkColor ($hdelete, "0xAA0000")
GUICtrlSetColor ($hdelete, "0xFFFFFF")
GUICtrlSetResizing (-1, $GUI_DOCKBOTTOM + $GUI_DOCKSIZE)

$hlogwindow = GUICreate("EM Tool Log", 320, 300, $left3, $top3, BitOr($WS_POPUP, $WS_THICKFRAME))
GUISetState(@SW_HIDE, $hlogwindow)
GUISetFont ( 10, 400, 0, "Arial")
$hlogtitle = GUICtrlCreateLabel("~SHIPS LOG~", 0, 0, 320, 20, $SS_CENTER, $GUI_WS_EX_PARENTDRAG)
GUICtrlSetColor ($hlogtitle, "0x000000")
GUICtrlSetBkColor ($hlogtitle, "0xCCCCCC")
GUICtrlSetResizing (-1, $GUI_DOCKTOP + $GUI_DOCKHEIGHT)

GUISetFont (8, 400, 0, "Arial")
$hlogedit = GUICtrlCreateEdit("" & @CR, 0, 20, 320, 240, BitOr($WS_VSCROLL, $WS_HSCROLL, $ES_AUTOVSCROLL, $ES_READONLY))
GUICtrlSetState($hlogedit, $GUI_SHOW)
GUICtrlSetResizing (-1, $GUI_DOCKBOTTOM + $GUI_DOCKTOP)

GUISetFont (8, 600, 0, "Arial")
$hclose = GUICtrlCreateButton("CLOSE", 40, 270, 60, 19)
GUICtrlSetBkColor ($hclose, "0xCCCCCC")
GUICtrlSetColor ($hclose, "0x000000")
GUICtrlSetResizing (-1, $GUI_DOCKBOTTOM + $GUI_DOCKSIZE)

$hclear = GUICtrlCreateButton("CLEAR", 130, 270, 60, 19)
GUICtrlSetBkColor ($hclear, "0xCCCCCC")
GUICtrlSetColor ($hclear, "0x000000")
GUICtrlSetResizing (-1, $GUI_DOCKBOTTOM + $GUI_DOCKSIZE)

$hlogdelete = GUICtrlCreateButton("DELETE", 220, 270, 60, 19)
GUICtrlSetBkColor ($hlogdelete, "0xAA0000")
GUICtrlSetColor ($hlogdelete, "0xFFFFFF")
GUICtrlSetResizing (-1, $GUI_DOCKBOTTOM + $GUI_DOCKSIZE)

GUISwitch($handle)
DirCreate("EMToolNotes")
GUISetFont ( 12, 400, 0, "Arial")
GUIRegisterMsg($WM_COMMAND, "MAP_WM_COMMAND")
GUIRegisterMsg($WM_MOUSEWHEEL, "WheelMsg")


While True
	If $usekeys = True Then
		GUIRegisterMsg($WM_ACTIVATE, "On_WM_ACTIVATE")
	EndIf
	If $windowchanged = True Then
		$windowchanged = False
		$array = WinGetClientSize("EM Tool v" & $version)
		If $array[0] <> 0 and $array[1] <> 0 Then
			$scalex = $array[0] / $windowx
			$scalez = $array[1] / $windowz
			$displayedmap = False

			GUICtrlSetFont($p1, 12 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($p81, 12 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($p3, 12 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($p2, 12 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($p4, 12 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($p5, 12 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($p6, 12 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($p7, 12 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($p8, 12 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($p68, 12 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($p69, 12 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($p94, 12 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($p15, 12 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($p12, 12 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($p13, 12 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($p14, 12 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($p9, 12 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($p10, 12 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($p11, 12 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($p16, 12 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($p21, 12 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($p22, 12 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($p23, 12 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($p24, 12 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($p82, 12 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($p71, 12 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($p70, 12 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($p40, 12 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($p17, 12 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($p18, 12 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($p19, 12 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($p20, 12 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($p78, 12 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($p25, 12 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($p75, 12 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($p27, 12 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($p76, 12 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($p28, 12 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($p31, 12 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($p30, 12 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($p29, 12 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($p32, 12 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($p33, 12 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($p34, 12 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($p79, 12 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($p51, 12 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($p52, 12 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($p53, 12 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($p54, 12 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($p55, 12 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($p56, 12 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($p57, 12 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($p58, 12 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($pbhull, 10 * $scalex, 400, 0, "Arial Black")
			GUICtrlSetFont($pbenergy, 10 * $scalex, 400, 0, "Arial Black")
			GUICtrlSetFont($pbengine, 10 * $scalex, 400, 0, "Arial Black")
			GUICtrlSetFont($pbweap, 10 * $scalex, 400, 0, "Arial Black")
			GUICtrlSetFont($pbnav, 10 * $scalex, 400, 0, "Arial Black")
			GUICtrlSetFont($pbfront, 10 * $scalex, 400, 0, "Arial Black")
			GUICtrlSetFont($pbright, 10 * $scalex, 400, 0, "Arial Black")
			GUICtrlSetFont($pbleft, 10 * $scalex, 400, 0, "Arial Black")
			GUICtrlSetFont($pbrear, 10 * $scalex, 400, 0, "Arial Black")
			GUICtrlSetFont($pbthull, 10 * $scalex, 400, 0, "Arial Black")
			GUICtrlSetFont($pbtfront, 10 * $scalex, 400, 0, "Arial Black")
			GUICtrlSetFont($pbtrear, 10 * $scalex, 400, 0, "Arial Black")
			GUICtrlSetFont($pbtleft, 10 * $scalex, 400, 0, "Arial Black")
			GUICtrlSetFont($pbtright, 10 * $scalex, 400, 0, "Arial Black")
			GUICtrlSetFont($pbtengine, 10 * $scalex, 400, 0, "Arial Black")
			GUICtrlSetFont($pbtweap, 10 * $scalex, 400, 0, "Arial Black")
			GUICtrlSetFont($pbtnav, 10 * $scalex, 400, 0, "Arial Black")
			GUICtrlSetFont($hcurrentmapx, 8 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($hcurrentmapz, 8 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($hzoom, 8 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($hinputx, 10 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($hinputz, 10 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($hinputs, 10 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($hscale, 8 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($hscale1, 8 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($hscale2, 8 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($hrate, 10 * $scalez, 400, 0, "Arial")
			GUICtrlSetFont($hrank, 10 * $scalez, 400, 0, "Arial")
		EndIf
	EndIf
	$state = GUICtrlRead ($soundcheck)
	If $state = $GUI_CHECKED Then
		$usesound = True
	Else
		$usesound = False
	EndIf
	$msg = GUIGetMsg()
	If $msg <> 0 Then
		If $msg = $GUI_EVENT_CLOSE Then ExitLoop
		If $msg = $GUI_EVENT_RESIZED Then $windowchanged = True
		If $msg = $GUI_EVENT_MAXIMIZE Then $windowchanged = True
		If $msg = $GUI_EVENT_MINIMIZE Then $windowchanged = True
		If $msg = $GUI_EVENT_RESTORE Then $windowchanged = True
		If $msg = $hlogbutton Then
			If $logopen <> True Then
				If FileExists(@WorkingDir & "\EM_Tool.log") Then
					If _FileReadToArray(@WorkingDir & "\EM_Tool.log", $log) Then
						For $x = 1 to $log[0]
							GUICtrlSetData($hlogedit, GUICtrlRead($hlogedit) & $log[$x] & @CRLF)
							GUISetState(@SW_SHOW, $hlogwindow)
						Next
					Else
						If @error <> 2 Then
							MsgBox(16, "ERROR", "Could not open " & @WorkingDir & "\EM_Tool.log")
						EndIf
						GUISetState(@SW_SHOW, $hlogwindow)
						GUICtrlSetData($hlogedit, "")
					EndIf
				Else
					GUISetState(@SW_SHOW, $hlogwindow)
					GUICtrlSetData($hlogedit, "")
				EndIf
				Logit("LOG OPENED *********************")
				$logopen = True
				GUICtrlSetImage($hlogbutton, "EM_Tool_Buttonlog_on.bmp")
				$lastlog = ""
			Else
				WinActivate("EM Tool Log", "SHIPS LOG")
			EndIf
			GUISwitch($handle)
		EndIf
		If $msg = $hclose Then
			;Logit("***** Log Closed *****")
			GUICtrlSetData($hlogedit, "")
			GUISetState(@SW_HIDE, $hlogwindow)
			$logopen = False
			GUICtrlSetImage($hlogbutton, "EM_Tool_Buttonlog.bmp")
		EndIf
		If $msg = $hclear Then
			GUICtrlSetData($hlogedit, "")
			Logit("LOG CLEARED ********************")
		EndIf
		If $msg = $hlogdelete Then
			$delete = MsgBox(49, "DELETE FILE", "Are you sure you want to DELETE this file ? " & @CR & @WorkingDir & "\EM_Tool.log")
			If $delete = 1 Then
				GUICtrlSetData($hlogedit, "")
				FileDelete(@WorkingDir & "\EM_Tool.log")
				Logit("LOG FILE DELETED ***************")
			Endif
		EndIf
		If $msg = $hnotebutton Then
			If $notesopen <> True Then
				$thisnotefile = $currentnotefile
				GUICtrlSetData($hnotewarn, "")
				GUICtrlSetData($hnotetitle, $thisnotefile)
				If $noteexists Then
					If _FileReadToArray(@WorkingDir & "\EMToolNotes\" & $thisnotefile, $notes) Then
						For $x = 1 to $notes[0]
							GUICtrlSetData($hedit, GUICtrlRead($hedit) & $notes[$x] & @CRLF)
							GUISetState(@SW_SHOW, $hnoteswindow)
						Next
						GUICtrlSetData($hedit, StringReplace(GUICtrlRead($hedit), _StringRepeat("-", 32), _StringRepeat(Chrw(0x2500), 32)))
					Else
						If @error <> 2 Then
							MsgBox(16, "ERROR", "Could not open " & @WorkingDir & "\EMToolNotes\" & $thisnotefile)
						EndIf
						GUISetState(@SW_SHOW, $hnoteswindow)
						GUICtrlSetData($hedit, $dataarray[15] & @CRLF & _StringRepeat(Chrw(0x2500), 32) & @CRLF)
					EndIf
				Else
					GUISetState(@SW_SHOW, $hnoteswindow)
					GUICtrlSetData($hedit, $dataarray[15] & @CRLF & _StringRepeat(Chrw(0x2500), 32) & @CRLF)
				EndIf
				$notesopen = True
			Else
				WinActivate("EM Tool Sector Notes", $thisnotefile)
			EndIf
			GUISwitch($handle)
		EndIf
		If $msg = $hsave Then
			If GUICtrlRead($hedit) <> "" Then
				FileDelete(@WorkingDir & "\EMToolNotes\" & $thisnotefile)
				FileWrite(@WorkingDir & "\EMToolNotes\" & $thisnotefile, GUICtrlRead($hedit))
			EndIf
			GUISetState(@SW_HIDE, $hnoteswindow)
			GUICtrlSetData($hedit, "")
			$notesopen = False
		EndIf
		If $msg = $hcancel Then
			GUISetState(@SW_HIDE, $hnoteswindow)
			GUICtrlSetData($hedit, "")
			$notesopen = False
		EndIf
		If $msg = $hdelete Then
			$delete = MsgBox(49, "DELETE FILE", "Are you sure you want to DELETE this file ? " & @CR & @WorkingDir & "\EMToolNotes\" & $thisnotefile)
			If $delete = 1 Then
				FileDelete(@WorkingDir & "\EMToolNotes\" & $thisnotefile)
				GUISetState(@SW_HIDE, $hnoteswindow)
				GUICtrlSetData($hedit, "")
				$notesopen = False
			EndIf
		EndIf
		If $msg = $hzoomin Then
			$zoom = $zoom + 1
			If $zoom > $maxzoom Then $zoom = $maxzoom
			$displayedmap = False
			GUICtrlSetData($hzoom, $zoom)
			GUICtrlSetData($hscale, $zoomfactor[$zoom][2])
			$zoomed = True
		EndIf
		If $msg = $hzoomout Then
			$zoom = $zoom - 1
			If $zoom < 1 Then $zoom = 1
			$displayedmap = False
			GUICtrlSetData($hzoom, $zoom)
			GUICtrlSetData($hscale, $zoomfactor[$zoom][2])
			$zoomed = True
		EndIf
		If $msg = $hfollow Then
			$follow = NOT $follow
			$displayedmap = False
			If $follow = True Then
				$go = False
				$wasgo = False
				GUICtrlSetImage ($hfollow, "EM_Tool_Buttonf_on.bmp")
			Else
				GUICtrlSetImage ($hfollow, "EM_Tool_Buttonf.bmp")
			EndIf
		EndIf
		If $msg = $hpanleft Then
			$follow = False
			$displayedmap = False
			GUICtrlSetImage ($hfollow, "EM_Tool_Buttonf.bmp")
			$perspectivex = $perspectivex - $zoomfactor[$zoom][2]
			$offsetx = $lastoffsetx + 1
		EndIf
		If $msg = $hpanright Then
			$follow = False
			$displayedmap = False
			GUICtrlSetImage ($hfollow, "EM_Tool_Buttonf.bmp")
			$perspectivex = $perspectivex + $zoomfactor[$zoom][2]
			$offsetx = $lastoffsetx - 1
		EndIf
		If $msg = $hpanup Then
			$follow = False
			$displayedmap = False
			GUICtrlSetImage ($hfollow, "EM_Tool_Buttonf.bmp")
			$perspectivez = $perspectivez + $zoomfactor[$zoom][2]
			$offsetz = $lastoffsetz - 1
		EndIf
		If $msg = $hpandown Then
			$follow = False
			$displayedmap = False
			GUICtrlSetImage ($hfollow, "EM_Tool_Buttonf.bmp")
			$perspectivez = $perspectivez - $zoomfactor[$zoom][2]
			$offsetz = $lastoffsetz + 1
		EndIf
		If $msg = $hgoto Then
			$gox = GUICtrlRead($hinputx)
			$goz = GUICtrlRead($hinputz)
			If $gox = "" Then $gox = 0
			If $goz = "" Then $goz = 0
			If (StringIsInt($gox) = 1) and (StringIsInt($goz) = 1) Then
				If ($gox >= -200000) and ($gox <= 200000) and ($goz >= -200000) and ($goz <= 200000) Then
					$perspectivex = $gox
					$perspectivez = $goz
					$follow = False
					$displayedmap = False
					GUICtrlSetImage ($hfollow, "EM_Tool_Buttonf.bmp")
					$go = True
				EndIf
			EndIf
		EndIf
		If $msg = $hsearch Then
			$searchfor = GUICtrlRead($hinputs)
			$found = 0
			If $searchfor <> "" Then
				For $x = 1 to $maplist[0]
					If $sectors[$x] = $searchfor Then
						$found = $x
						ExitLoop
					EndIf
				Next
				If $found = 0 Then
					For $x = 1 to $maplist[0]
						If StringInstr($sectors[$x], $searchfor, 2) > 0 Then
							$found = $x
							ExitLoop
						EndIf
					Next
				EndIf
				If $found > 0 Then
					$gox = $sectorssx[$found]
					$goz = $sectorssz[$found]
					If $gox = "" Then $gox = 0
					If $goz = "" Then $goz = 0
					If (StringIsInt($gox) = 1) and (StringIsInt($goz) = 1) Then
						If ($gox >= -200000) and ($gox <= 200000) and ($goz >= -200000) and ($goz <= 200000) Then
							$perspectivex = $gox
							$perspectivez = $goz
							$follow = False
							$displayedmap = False
							GUICtrlSetImage ($hfollow, "EM_Tool_Buttonf.bmp")
							$go = True
						EndIf
					EndIf
				Else
					GUICtrlSetData($hinputs, "NOT FOUND !")
				EndIf
			Else
				GUICtrlSetData($hinputs, "NO CRITERIA !")
			EndIf
		EndIf
		If $msg = $hreload Then
			LoadMap(True)
			$displayedmap = False
		EndIf
		
		If $MapDblClkFlg <> 0 then
			doNotes($MapDblClkFlg)
			GUISwitch($handle)
			$MapDblClkFlg = 0
		EndIf
	EndIf


	If TimerDiff($begin) >= $delay or $msg <> 0 Then
		$timediff = _DateDiff("s", $starttime, _NowCalc())
		If $lasttimediff <> $timediff Then
			$leftover = 0
			$hours = 0
			$minutes = 0
			$seconds = 0
			If $timediff > 0 Then
				If $timediff > 3600 Then
					$hours = Int($timediff / 3600)
					$leftover = Mod($timediff, 3600)
				Else
					$hours = "0"
					$leftover = $timediff
				EndIf
				If $leftover > 60 Then
					$minutes = Int($leftover / 60)
					If StringLen($minutes) < 2 Then $minutes = "0" & $minutes
					$seconds = Mod($leftover, 60)
				Else
					$minutes = "00"
					$seconds = $leftover
				EndIf
				If StringLen($seconds) < 2 Then $seconds = "0" & $seconds
			Else
				$hours = "0"
				$minutes = "00"
				$seconds = "00"
			EndIf
			If $seconds = 60 Then
				$minutes = $minutes + 1
				If StringLen($minutes) < 2 Then $minutes = "0" & $minutes
				$seconds = "00"
			Endif
			If $minutes = 60 Then
				$hours = $hours + 1
				$minutes = "00"
			Endif
			$timeonline = $hours & ":" & $minutes & ":" & $seconds
			GUICtrlSetData($htimeonline, $timeonline)
			$lasttimediff = $timediff
		EndIf
		If TimerDiff($begin) >= $delay Then
			If _FileReadToArray($savedatafile, $dataarray) Then
				$currentnotefile = "EM_Tool_Notes_" & $dataarray[12] & "_" & $dataarray[13] & "_" & $dataarray[14] & ".txt"
				If $currentnotefile <> $lastnotefile Then
					If $thisnotefile <> $currentnotefile Then
						GUICtrlSetData($hnotewarn, "Note: You are not in this sector")
					Else
						GUICtrlSetData($hnotewarn, "")
					EndIf
					If FileExists(@WorkingDir & "\EMToolNotes\" & $currentnotefile) Then
						GUICtrlSetImage($hnotebutton, "EM_Tool_Buttonn_note.bmp")
						$noteexists = True
					Else
						GUICtrlSetImage($hnotebutton, "EM_Tool_Buttonn.bmp")
						$noteexists = False
					EndIf
				EndIf
				If $logopen = True Then
					$thislog = "SX:" & $dataarray[12] & " SY:" & $dataarray[13] & " SZ:" & $dataarray[14]
					If $lastlog <> $thislog Then
						$lastlog = $thislog
						Logit($thislog & " - " & $dataarray[15] & " - Fuel: " & $fuel[1])
						_GUICtrlEdit_Scroll($hlogedit, $SB_SCROLLCARET)
					EndIf
				EndIf
				If $dataarray[62] <> $datacheck[62] Then
					$datacheck[62] = $dataarray[62]
					For $x = 1 to 5
						If $x > $dataarray[62] Then
							GUICtrlSetState ($cb[$x], $GUI_SHOW)
						Else
							GUICtrlSetState ($cb[$x], $GUI_HIDE)
						EndIf
					Next
				EndIf

				If $dataarray[1] <> $datacheck[1] Then
					$datacheck[1] = $dataarray[1]
					GUICtrlSetData($p1, $dataarray[1])
				EndIf
				If $dataarray[2] <> $datacheck[2] Then
					$datacheck[2] = $dataarray[2]
					$fuel = StringSplit ($dataarray[2], "/")
					GUICtrlSetData($p2, $fuel[1] & " / " & $fuel[2])
					If $fuel[1] < 1 or $fuel[2] < 1 Then
						$fperc = 0
					Else
						$fperc = (100 / $fuel[2]) * $fuel[1]
					EndIf
					If $fperc < $minfuel Then
						GUICtrlSetColor ($P2, "0xFF0000")
					ElseIf $fperc < 60 Then
						GUICtrlSetColor ($P2, "0xFFFF00")
					Else
						GUICtrlSetColor ($P2, "0xFFFFFF")
					EndIf
				EndIf
				If $fperc < $minfuel Then
					If $usesound = True Then
						If TimerDiff($fuelalert) >= 11000 Then
							If $wavs = FALSE Then
								Beep(500, 500)
							Else
								SoundPlay ("EM_Tool_Fuel.wav")
							EndIf
							$fuelalert = TimerInit()
						EndIf
					EndIf
				EndIf
				If $dataarray[81] <> $datacheck[81] Then
					$datacheck[81] = $dataarray[81]
					GUICtrlSetData($p81, $dataarray[81])
				EndIf
				If $dataarray[3] <> $datacheck[3] Then
					$datacheck[3] = $dataarray[3]
					GUICtrlSetData($p3, $dataarray[3])
				EndIf
				If $dataarray[4] <> $datacheck[4] Then
					$datacheck[4] = $dataarray[4]
					GUICtrlSetData($p4, Iif($dataarray[4] = "Empty", "", $dataarray[4]))
				EndIf
				If $dataarray[5] <> $datacheck[5] Then
					$datacheck[5] = $dataarray[5]
					GUICtrlSetData($p5, Iif($dataarray[5] = "Empty", "", $dataarray[5]))
				EndIf
				If $dataarray[6] <> $datacheck[6] Then
					$datacheck[6] = $dataarray[6]
					GUICtrlSetData($p6, Iif($dataarray[6] = "Empty", "", $dataarray[6]))
				EndIf
				If $dataarray[7] <> $datacheck[7] Then
					$datacheck[7] = $dataarray[7]
					GUICtrlSetData($p7, Iif($dataarray[7] = "Empty", "", $dataarray[7]))
				EndIf
				If $dataarray[8] <> $datacheck[8] Then
					$datacheck[8] = $dataarray[8]
					GUICtrlSetData($p8, Iif($dataarray[8] = "Empty", "", $dataarray[8]))
				EndIf
				If $dataarray[68] <> $datacheck[68] Then
					$datacheck[68] = $dataarray[68]
					GUICtrlSetData($p68, $dataarray[68])
				EndIf
				If $dataarray[69] <> $datacheck[69] Then
					$datacheck[69] = $dataarray[69]
					GUICtrlSetData($p69, $dataarray[69])
				EndIf
				If $dataarray[94] <> $datacheck[94] Then
					$datacheck[94] = $dataarray[94]
					GUICtrlSetData($p94, $dataarray[94])
					If $dataarray[94] = 0 then
						GUICtrlSetColor ($P94, "0xFFFFFF")
					Else
						GUICtrlSetColor ($P94, "0xFFFF00")
					EndIf
				EndIf
				If $dataarray[94] <> 0 then
					If $usesound = True Then
						If TimerDiff($alert) >= 10000 Then
							If $wavs = FALSE Then
								Beep(1000, 300)
								Beep(1000, 300)
								Beep(1000, 300)
							Else
								SoundPlay ("EM_Tool_Hostile.wav")
							EndIf
							$alert = TimerInit()
						EndIf
					EndIf
				EndIf
				If $dataarray[15] <> $datacheck[15] Then
					$datacheck[15] = $dataarray[15]
					GUICtrlSetData($p15, $dataarray[15])
				EndIf
				If $dataarray[12] <> $datacheck[12] Then
					$datacheck[12] = $dataarray[12]
					GUICtrlSetData($p12, $dataarray[12])
				EndIf
				If $dataarray[13] <> $datacheck[13] Then
					$datacheck[13] = $dataarray[13]
					GUICtrlSetData($p13, $dataarray[13])
				EndIf
				If $dataarray[14] <> $datacheck[14] Then
					$datacheck[14] = $dataarray[14]
					GUICtrlSetData($p14, $dataarray[14])
				EndIf
				If $dataarray[9] <> $datacheck[9] Then
					$datacheck[9] = $dataarray[9]
					GUICtrlSetData($p9, $dataarray[9])
				EndIf
				If $dataarray[10] <> $datacheck[10] Then
					$datacheck[10] = $dataarray[10]
					GUICtrlSetData($p10, $dataarray[10])
				EndIf
				If $dataarray[11] <> $datacheck[11] Then
					$datacheck[11] = $dataarray[11]
					GUICtrlSetData($p11, $dataarray[11])
				EndIf
				If $dataarray[16] <> $datacheck[16] Then
					$datacheck[16] = $dataarray[16]
					GUICtrlSetData($p16, $dataarray[16] & "%")
					If $dataarray[16] < 60 Then
						GUICtrlSetColor ($P16, "0xFF0000")
						GUICtrlSetColor ($pbenergy, "0xFF0000")
					ElseIf $dataarray[16] < 95 Then
						GUICtrlSetColor ($P16, "0xFFFF00")
						GUICtrlSetColor ($pbenergy, "0xFFFF00")
					Else
						GUICtrlSetColor ($P16, "0xFFFFFF")
						GUICtrlSetColor ($pbenergy, "0x00FF00")
					EndIf
					GUICtrlSetData($pbenergy, Level($dataarray[16]))
				EndIf
				If $dataarray[21] <> $datacheck[21] Then
					$datacheck[21] = $dataarray[21]
					GUICtrlSetData($p21, $dataarray[21] & "%")
					If $dataarray[21] < 60 Then
						GUICtrlSetColor ($P21, "0xFF0000")
						GUICtrlSetColor ($pbhull, "0xFF0000")
					ElseIf $dataarray[21] < 95 Then
						GUICtrlSetColor ($P21, "0xFFFF00")
						GUICtrlSetColor ($pbhull, "0xFFFF00")
					Else
						GUICtrlSetColor ($P21, "0xFFFFFF")
						GUICtrlSetColor ($pbhull, "0x00FF00")
					EndIf
					GUICtrlSetData($pbhull, Level($dataarray[21]))
				EndIf
				If $dataarray[22] <> $datacheck[22] Then
					$datacheck[22] = $dataarray[22]
					GUICtrlSetData($p22, $dataarray[22] & "%")
					If $dataarray[22] < 60 Then
						GUICtrlSetColor ($P22, "0xFF0000")
						GUICtrlSetColor ($pbengine, "0xFF0000")
					ElseIf $dataarray[22] < 95 Then
						GUICtrlSetColor ($P22, "0xFFFF00")
						GUICtrlSetColor ($pbengine, "0xFFFF00")
					Else
						GUICtrlSetColor ($P22, "0xFFFFFF")
						GUICtrlSetColor ($pbengine, "0x00FF00")
					EndIf
					GUICtrlSetData($pbengine, Level($dataarray[22]))
				EndIf
				If $dataarray[23] <> $datacheck[23] Then
					$datacheck[23] = $dataarray[23]
					GUICtrlSetData($p23, $dataarray[23] & "%")
					If $dataarray[23] < 60 Then
						GUICtrlSetColor ($P23, "0xFF0000")
						GUICtrlSetColor ($pbweap, "0xFF0000")
					ElseIf $dataarray[23] < 95 Then
						GUICtrlSetColor ($P23, "0xFFFF00")
						GUICtrlSetColor ($pbweap, "0xFFFF00")
					Else
						GUICtrlSetColor ($P23, "0xFFFFFF")
						GUICtrlSetColor ($pbweap, "0x00FF00")
					EndIf
					GUICtrlSetData($pbweap, Level($dataarray[23]))
				EndIf
				If $dataarray[24] <> $datacheck[24] Then
					$datacheck[24] = $dataarray[24]
					GUICtrlSetData($p24, $dataarray[24] & "%")
					If $dataarray[24] < 60 Then
						GUICtrlSetColor ($P24, "0xFF0000")
						GUICtrlSetColor ($pbnav, "0xFF0000")
					ElseIf $dataarray[24] < 95 Then
						GUICtrlSetColor ($P24, "0xFFFF00")
						GUICtrlSetColor ($pbnav, "0xFFFF00")
					Else
						GUICtrlSetColor ($P24, "0xFFFFFF")
						GUICtrlSetColor ($pbnav, "0x00FF00")
					EndIf
					GUICtrlSetData($pbnav, Level($dataarray[24]))
				EndIf
				If $dataarray[82] <> $datacheck[82] Then
					$datacheck[82] = $dataarray[82]
					GUICtrlSetData($p82, $dataarray[82])
					If $dataarray[82] = "0S/0W" Then
						GUICtrlSetColor ($P82, "0xFFFFFF")
					Else
						GUICtrlSetColor ($P82, "0xFFFF00")
					EndIf
				EndIf
				If $dataarray[71] <> $datacheck[71] Then
					$datacheck[71] = $dataarray[71]
					GUICtrlSetData($p71, $dataarray[71])
					$temp = $ranks[10][2]
					For $x = 1 to 9
						If $datacheck[71] <= $ranks[$x][1] Then
							$temp = $ranks[$x][2]
							ExitLoop
						EndIf
					Next
					GUICtrlSetData($hrank, $temp)
				EndIf
				If $dataarray[70] <> $datacheck[70] Then
					$datacheck[70] = $dataarray[70]
					GUICtrlSetData($p70, $dataarray[70])
					$temp = $rates[10][2]
					For $x = 1 to 9
						If $datacheck[70] <= $rates[$x][1] Then
							$temp = $rates[$x][2]
							ExitLoop
						EndIf
					Next
					GUICtrlSetData($hrate, $temp)
				EndIf
				If $dataarray[40] = 1 then
					GUICtrlSetData($p40, "    !!! INCOMING !!!")
					If $blink = True then
						GUICtrlSetColor ($P40, "0xFF8800")
						$blink = False
					Else
						GUICtrlSetColor ($P40, "0xFF0000")
						$blink = True
					EndIf
					$dots = 0
				Else
					$dots = $dots + 1
					If $dots > 17 then $dots = 0
					$x = 0
					$dotstring = ""
					While $x < $dots
						$dotstring &= ""
						$x += 1
					WEnd
					GUICtrlSetData($p40, $dotstring)
					GUICtrlSetColor ($P40, "0x00FFFF")
					$blink = False
				EndIf
				If $dataarray[17] <> $datacheck[17] Then
					$datacheck[17] = $dataarray[17]
					GUICtrlSetData($p17, $dataarray[17] & "%")
					If $dataarray[17] < 50 Then
						GUICtrlSetColor ($P17, "0xFF0000")
						GUICtrlSetColor ($pbfront, "0xFF0000")
					ElseIf $dataarray[17] < 99 Then
						GUICtrlSetColor ($P17, "0xFFFF00")
						GUICtrlSetColor ($pbfront, "0xFFFF00")
					Else
						GUICtrlSetColor ($P17, "0xFFFFFF")
						GUICtrlSetColor ($pbfront, "0x00FF00")
					EndIf
					GUICtrlSetData($pbfront, Level($dataarray[17]))
				EndIf
				If $dataarray[18] <> $datacheck[18] Then
					$datacheck[18] = $dataarray[18]
					GUICtrlSetData($p18, $dataarray[18] & "%")
					If $dataarray[18] < 50 Then
						GUICtrlSetColor ($P18, "0xFF0000")
						GUICtrlSetColor ($pbright, "0xFF0000")
					ElseIf $dataarray[18] < 99 Then
						GUICtrlSetColor ($P18, "0xFFFF00")
						GUICtrlSetColor ($pbright, "0xFFFF00")
					Else
						GUICtrlSetColor ($P18, "0xFFFFFF")
						GUICtrlSetColor ($pbright, "0x00FF00")
					EndIf
					GUICtrlSetData($pbright, Level($dataarray[18]))
				EndIf
				If $dataarray[19] <> $datacheck[19] Then
					$datacheck[19] = $dataarray[19]
					GUICtrlSetData($p19, $dataarray[19] & "%")
					If $dataarray[19] < 50 Then
						GUICtrlSetColor ($P19, "0xFF0000")
						GUICtrlSetColor ($pbleft, "0xFF0000")
					ElseIf $dataarray[19] < 99 Then
						GUICtrlSetColor ($P19, "0xFFFF00")
						GUICtrlSetColor ($pbleft, "0xFFFF00")
					Else
						GUICtrlSetColor ($P19, "0xFFFFFF")
						GUICtrlSetColor ($pbleft, "0x00FF00")
					EndIf
					GUICtrlSetData($pbleft, Level($dataarray[19]))
				EndIf
				If $dataarray[20] <> $datacheck[20] Then
					$datacheck[20] = $dataarray[20]
					GUICtrlSetData($p20, $dataarray[20] & "%")
					If $dataarray[20] < 50 Then
						GUICtrlSetColor ($P20, "0xFF0000")
						GUICtrlSetColor ($pbrear, "0xFF0000")
					ElseIf $dataarray[20] < 99 Then
						GUICtrlSetColor ($P20, "0xFFFF00")
						GUICtrlSetColor ($pbrear, "0xFFFF00")
					Else
						GUICtrlSetColor ($P20, "0xFFFFFF")
						GUICtrlSetColor ($pbrear, "0x00FF00")
					EndIf
					GUICtrlSetData($pbrear, Level($dataarray[20]))
				EndIf
				;"HEAT"
				If $dataarray[78] <> $datacheck[78] Then
					$datacheck[78] = $dataarray[78]
					If $dataarray[78] = 1 Then
						GUICtrlSetColor ($P78, "0xFF4400")
					Else
						GUICtrlSetColor ($P78, "0x000000")
					EndIf
				EndIf
				If $datacheck[26] <> $dataarray[26] Then
					If ($dataarray[25] = "") and ($dataarray[75] = "") Then
						$threat = "0x000000"
					Elseif $dataarray[26] = "High" Then
						$threat = "0xFF0000"
					ElseIf	$dataarray[26] = "Med" Then
						$threat = "0xFFFF00"
					Else
						$threat = "0xFFFFFF"
					EndIf
					$datacheck[26] = $dataarray[26]
					$threatchanged = True
				Else
					$threatchanged = False
				EndIf
				If ($dataarray[25] <> $datacheck[25]) or ($threatchanged = True) Then
					$targetchanged = TRUE
					$datacheck[25] = $dataarray[25]
					GUICtrlSetData($p25, $dataarray[25])
					GUICtrlSetColor ($P25, $threat)
				Else
					$targetchanged = FALSE
				EndIf
				If $dataarray[93] = 0 Then
					If ($dataarray[75] <> $datacheck[75]) or ($targetchanged = TRUE) or ($threatchanged = True) Then
						$datacheck[75] = $dataarray[75]
						GUICtrlSetData($p75, $dataarray[75])
						GUICtrlSetColor ($P75, $threat)
						$targetchanged = TRUE
					EndIf
				Else
					If ($dataarray[75] <> $datacheck[75]) or ($targetchanged = TRUE) or ($threatchanged = True) Then
						$datacheck[75] = $dataarray[75]
						GUICtrlSetData($p75, "?")
						GUICtrlSetColor ($P75, $threat)
						$targetchanged = TRUE
					EndIf
				EndIf
				If ($dataarray[27] <> $datacheck[27]) or ($targetchanged = TRUE) or ($threatchanged = True) Then
					$datacheck[27] = $dataarray[27]
					GUICtrlSetData($p27, $dataarray[27])
					GUICtrlSetColor ($P27, $threat)
				EndIf
				If ($dataarray[76] <> $datacheck[76]) or ($targetchanged = TRUE) or ($threatchanged = True) Then
					$datacheck[76] = $dataarray[76]
					GUICtrlSetData($p76, $dataarray[76] & "%")
					GUICtrlSetColor ($P76, $threat)
					GUICtrlSetData($pbthull, Level($dataarray[76]))
					GUICtrlSetColor ($pbthull, Iif($threat = "0xFFFFFF", "0x888888", $threat))
				EndIf
				If ($dataarray[28] <> $datacheck[28]) or ($targetchanged = TRUE) or ($threatchanged = True) Then
					$datacheck[28] = $dataarray[28]
					GUICtrlSetData($p28, $dataarray[28] & "%")
					GUICtrlSetColor ($P28, $threat)
					GUICtrlSetData($pbtfront, Level($dataarray[28]))
					GUICtrlSetColor ($pbtfront, Iif($threat = "0xFFFFFF", "0x888888", $threat))
				EndIf
				If ($dataarray[31] <> $datacheck[31]) or ($targetchanged = TRUE) or ($threatchanged = True) Then
					$datacheck[31] = $dataarray[31]
					GUICtrlSetData($p31, $dataarray[31] & "%")
					GUICtrlSetColor ($P31, $threat)
					GUICtrlSetData($pbtrear, Level($dataarray[31]))
					GUICtrlSetColor ($pbtrear, Iif($threat = "0xFFFFFF", "0x888888", $threat))
				EndIf
				If ($dataarray[30] <> $datacheck[30]) or ($targetchanged = TRUE) or ($threatchanged = True) Then
					$datacheck[30] = $dataarray[30]
					GUICtrlSetData($p30, $dataarray[30] & "%")
					GUICtrlSetColor ($P30, $threat)
					GUICtrlSetData($pbtleft, Level($dataarray[30]))
					GUICtrlSetColor ($pbtleft, Iif($threat = "0xFFFFFF", "0x888888", $threat))
				EndIf
				If ($dataarray[29] <> $datacheck[29]) or ($targetchanged = TRUE) or ($threatchanged = True) Then
					$datacheck[29] = $dataarray[29]
					GUICtrlSetData($p29, $dataarray[29] & "%")
					GUICtrlSetColor ($P29, $threat)
					GUICtrlSetData($pbtright, Level($dataarray[29]))
					GUICtrlSetColor ($pbtright, Iif($threat = "0xFFFFFF", "0x888888", $threat))
				EndIf
				If ($dataarray[32] <> $datacheck[32]) or ($targetchanged = TRUE) or ($threatchanged = True) Then
					$datacheck[32] = $dataarray[32]
					GUICtrlSetData($p32, $dataarray[32] & "%")
					GUICtrlSetColor ($P32, $threat)
					GUICtrlSetData($pbtengine, Level($dataarray[32]))
					GUICtrlSetColor ($pbtengine, Iif($threat = "0xFFFFFF", "0x888888", $threat))
				EndIf
				If ($dataarray[33] <> $datacheck[33]) or ($targetchanged = TRUE) or ($threatchanged = True) Then
					$datacheck[33] = $dataarray[33]
					GUICtrlSetData($p33, $dataarray[33] & "%")
					GUICtrlSetColor ($P33, $threat)
					GUICtrlSetData($pbtweap, Level($dataarray[33]))
					GUICtrlSetColor ($pbtweap, Iif($threat = "0xFFFFFF", "0x888888", $threat))
				EndIf
				If ($dataarray[34] <> $datacheck[34]) or ($targetchanged = TRUE) or ($threatchanged = True) Then
					$datacheck[34] = $dataarray[34]
					GUICtrlSetData($p34, $dataarray[34] & "%")
					GUICtrlSetColor ($P34, $threat)
					GUICtrlSetData($pbtnav, Level($dataarray[34]))
					GUICtrlSetColor ($pbtnav, Iif($threat = "0xFFFFFF", "0x888888", $threat))
				EndIf
				If $dataarray[79] <> $datacheck[79] Then
					$datacheck[79] = $dataarray[79]
					If $dataarray[79] = 0 Then
						GUICtrlSetData($p79, "OFF")
						GUICtrlSetColor ($P79, "0x888888")
					ElseIf $dataarray[79] = 1 Then
						GUICtrlSetData($p79, "ON")
						GUICtrlSetColor ($P79, "0xFFFFFF")
					Else
						GUICtrlSetData($p79, "LOCK")
						GUICtrlSetColor ($P79, "0xFFFF00")
					EndIf
				EndIf
				If $dataarray[51] <> $datacheck[51] Then
					$datacheck[51] = $dataarray[51]
					GUICtrlSetData($p51, Iif($dataarray[51] = "Empty", "", $dataarray[51]))
				EndIf
				If $dataarray[52] <> $datacheck[52] Then
					$datacheck[52] = $dataarray[52]
					GUICtrlSetData($p52, Iif($dataarray[52] = "Empty", "", $dataarray[52]))
				EndIf
				If $dataarray[53] <> $datacheck[53] Then
					$datacheck[53] = $dataarray[53]
					GUICtrlSetData($p53, Iif($dataarray[53] = "Empty", "", $dataarray[53]))
				EndIf
				If $dataarray[54] <> $datacheck[54] Then
					$datacheck[54] = $dataarray[54]
					GUICtrlSetData($p54, Iif($dataarray[54] = "Empty", "", $dataarray[54]))
				EndIf
				If $dataarray[55] <> $datacheck[55] Then
					$datacheck[55] = $dataarray[55]
					GUICtrlSetData($p55, Iif($dataarray[55] = "Empty", "", $dataarray[55]))
				EndIf
				If $dataarray[56] <> $datacheck[56] Then
					$datacheck[56] = $dataarray[56]
					GUICtrlSetData($p56, Iif($dataarray[56] = "Empty", "", $dataarray[56]))
				EndIf
				If $dataarray[57] <> $datacheck[57] Then
					$datacheck[57] = $dataarray[57]
					GUICtrlSetData($p57, Iif($dataarray[57] = "Empty", "", $dataarray[57]))
				EndIf
				If $dataarray[58] <> $datacheck[58] Then
					$datacheck[58] = $dataarray[58]
					GUICtrlSetData($p58, Iif($dataarray[58] = "Empty", "", $dataarray[58]))
				EndIf

			EndIf
		EndIf

;----------
		$currentsector = $dataarray[15]
		If ($currentsector <> "") and $updatemap = True Then
			_ArraySearch($sectors, $currentsector, 1, $maplist[0])
			If @error = 6 Then
				$newitem = _ArrayAdd($maplist, "Sector=" & $currentsector & ",SX=" & $dataarray[12] & ",SY=" & $dataarray[13] & ",SZ=" & $dataarray[14] & ",ZOOM1=HIDE,ZOOM2=UP,ZOOM3=UP,ZOOM4=UP,ZOOM5=UP,ZOOM6=UP,ZOOM7=UP")
				$maplist[0] = $newitem
				FileWriteLine ( "EM_Tool.txt", $maplist[$newitem])
				_ArrayAdd($sectors, $currentsector)
				_ArrayAdd($sectorssx, $dataarray[12])
				_ArrayAdd($sectorssy, $dataarray[13])
				_ArrayAdd($sectorssz, $dataarray[14])
				_ArrayAdd($sectorzoom1, "UP")
				_ArrayAdd($sectorzoom2, "UP")
				_ArrayAdd($sectorzoom3, "UP")
				_ArrayAdd($sectorzoom4, "UP")
				_ArrayAdd($sectorzoom5, "UP")
				_ArrayAdd($sectorzoom6, "UP")
				_ArrayAdd($sectorzoom7, "UP")
				_ArrayAdd($maplabels, "")
				_ArrayAdd($mapnames, "")
				_ArrayAdd($mapcoords, "")
				GUISetFont ( 8, 400, 0, "Arial")
				$maplabels[$newitem] = GUICtrlCreateLabel(" ", 0, 0, 4,4)
;				GUICtrlSetStyle($maplabels[$newitem], BitOR($WS_TABSTOP, $BS_NOTIFY, $BS_OWNERDRAW))
				GUICtrlSetResizing(-1, $GUI_DOCKSIZE)
				GUICtrlSetColor ($maplabels[$newitem], "0xFFFF00")
				GUICtrlSetBkColor ($maplabels[$newitem], "0xFFFF00")
				GUICtrlSetState ($maplabels[$newitem], $GUI_HIDE)
				$y = (StringLen($sectors[$newitem]) * 6.3)
				$y = Round($y, 0)
				If $y < 30 Then $y = 32
				$mapnames[$newitem] = GUICtrlCreateLabel($sectors[$newitem], 0, 0, $y,12)
				GUICtrlSetResizing(-1, $GUI_DOCKSIZE)
				GUICtrlSetColor ($mapnames[$newitem], "0xFFFFFF")
				GUICtrlSetBkColor ($mapnames[$newitem], $GUI_BKCOLOR_TRANSPARENT)
				GUICtrlSetState ($mapnames[$newitem], $GUI_HIDE)
				$y = ((StringLen($sectorssx[$newitem]) + StringLen($sectorssz[$newitem]) + 2) * 6.3)
				$y = Round($y, 0)
				If $y < 30 Then $y = 32
				$mapcoords[$newitem] = GUICtrlCreateLabel("(" & $sectorssx[$newitem] & "," & $sectorssz[$newitem] & ")", 0, 0, $y, 10)
				GUICtrlSetResizing(-1, $GUI_DOCKSIZE)
				GUICtrlSetColor ($mapcoords[$newitem], "0xFFFFFF")
				GUICtrlSetBkColor ($mapcoords[$newitem], $GUI_BKCOLOR_TRANSPARENT)
				GUICtrlSetState ($mapcoords[$newitem], $GUI_HIDE)
				$displayedmap = False
			EndIf
		EndIf

		If $follow = True or $go = True or $zoomed = True Then
			If $follow = True Then
				$currentxx = $dataarray[12]
				$currentzz = $dataarray[14]
				$perspectivex = $currentxx
				$perspectivez = $currentzz
				$zoomed = False
			ElseIf $go = True Then
				$currentxx = $perspectivex
				$currentzz = $perspectivez
				$go = False
				$wasgo = True
				$zoomed = False
			Else
				$currentxx = $perspectivex
				$currentzz = $perspectivez
				$zoomed = False
			EndIf
			$offsetx = 0
			$offsetz = 0
			If $zoom >= 3 Then
				$cfactor = 0.75
			Else
				$cfactor = 1
			EndIf
			While $currentxx > (($zoomfactor[$zoom][1]*$cfactor) - $zoomfactor[$zoom][2])
				$currentxx = $currentxx - $zoomfactor[$zoom][2]
				$offsetx = $offsetx - 1
			WEnd
			While $currentxx < ((($zoomfactor[$zoom][1]*$cfactor) - $zoomfactor[$zoom][2]) * -1)
				$currentxx = $currentxx + $zoomfactor[$zoom][2]
				$offsetx = $offsetx + 1
			WEnd
			While $currentzz > (($zoomfactor[$zoom][1]*$cfactor) - $zoomfactor[$zoom][2])
				$currentzz = $currentzz - $zoomfactor[$zoom][2]
				$offsetz = $offsetz - 1
			WEnd
			While $currentzz < ((($zoomfactor[$zoom][1]*$cfactor) - $zoomfactor[$zoom][2]) * -1)
				$currentzz = $currentzz + $zoomfactor[$zoom][2]
				$offsetz = $offsetz + 1
			WEnd
		EndIf

		If $zoom < $MAPCHLVL Then
			If ($offsetx <> $lastoffsetx) OR ($offsetz <> $lastoffsetz) or ($displayedmap = False) Then
				For $x = 1 to $objectlist[0]
					GUICtrlSetState ($objectlabels[$x], $GUI_HIDE)
					GUICtrlSetState ($objectnames[$x], $GUI_HIDE)
				Next
				$currentmapx = ($offsetx * $zoomfactor[$zoom][2]) * -1
				$currentmapz = ($offsetz * $zoomfactor[$zoom][2]) * -1
				GUICtrlSetData($hcurrentmapx, $currentmapx)
				$y = StringLen($currentmapz)
				$array = StringSplit ($currentmapz, "")
				$temp = ""
				For $x =  1 to $array[0]
					$temp = $temp & $array[$x] & @CR
					$currentmapz = $temp
				Next
				If $y < 8 Then
					For $x = 1 to Int(((Iif($array[1] = "-", 8, 7) - $y)) / 2)
						$currentmapz = " " & @CR & $currentmapz
					Next
				EndIf
				GUICtrlSetData($hcurrentmapz, $currentmapz)

				For $x = 1 To $maplist[0]
					If ($sectorssx[$x] + ($zoomfactor[$zoom][2] * $offsetx) <= $zoomfactor[$zoom][1]) and ($sectorssx[$x] + ($zoomfactor[$zoom][2] * $offsetx) >= $zoomfactor[$zoom][1] * -1) and ($sectorssz[$x] + ($zoomfactor[$zoom][2] * $offsetz) <= $zoomfactor[$zoom][1]) and ($sectorssz[$x] + ($zoomfactor[$zoom][2] * $offsetz) >= $zoomfactor[$zoom][1] * -1) Then
						$sx = $sectorssx[$x] + ($zoomfactor[$zoom][2] * $offsetx)
						$sz = $sectorssz[$x] + ($zoomfactor[$zoom][2] * $offsetz)
						$sx = ($zoomfactor[$zoom][1] + $sx)
						If $sx > 0 Then
							$sx = ($sx / $zoomfactor[$zoom][3])
						EndIf
						$sz = ($zoomfactor[$zoom][1] - $sz)
						If $sz > 0 Then
							$sz = ($sz / $zoomfactor[$zoom][3])
						EndIf
						$sx = ($sx + 299) * $scalex
						$sz = ($sz + 148) * $scalez
						$sx = Ceiling($sx)
						$sz = Ceiling($sz)

						GUICtrlSetPos ($maplabels[$x], $sx, $sz)

						$sectorslabel[1] = $sectorzoom1[$x]
						$sectorslabel[2] = $sectorzoom2[$x]
						$sectorslabel[3] = $sectorzoom3[$x]
						$sectorslabel[4] = $sectorzoom4[$x]
						$sectorslabel[5] = $sectorzoom5[$x]
						$sectorslabel[6] = $sectorzoom6[$x]
						$sectorslabel[7] = $sectorzoom7[$x]

						If StringInStr($sectorslabel[$zoom],"DOWN") > 0 Then
							GUICtrlSetPos ($mapnames[$x], $sx - 12, $sz + 4)
							GUICtrlSetPos ($mapcoords[$x], $sx - 12, $sz + 15)
						ElseIf StringInStr($sectorslabel[$zoom],"LEFT") > 0 Then
							$y = (StringLen($sectors[$x]) * 6.2)
							$y = Round($y, 0)
							If $y < 30 Then $y = 32
							GUICtrlSetPos ($mapnames[$x], $sx - $y - 2, $sz - 4)
							GUICtrlSetPos ($mapcoords[$x], $sx - $y - 2, $sz + 7)
						ElseIf StringInStr($sectorslabel[$zoom],"RIGHT") > 0 Then
							GUICtrlSetPos ($mapnames[$x], $sx + 7, $sz - 4)
							GUICtrlSetPos ($mapcoords[$x], $sx + 7, $sz + 7)
						Else	; "UP"
							IF StringInStr($sectorslabel[$zoom],"-P") > 0 Then
								GUICtrlSetPos ($mapnames[$x], $sx - 12, $sz - 14)
							Else
								GUICtrlSetPos ($mapnames[$x], $sx - 12, $sz - 25)
							EndIf
							GUICtrlSetPos ($mapcoords[$x], $sx - 12, $sz - 14)
						EndIf
						If StringInStr($sectorslabel[$zoom],"HIDE") > 0 Then
							GUICtrlSetState ($maplabels[$x], $GUI_HIDE)
							GUICtrlSetState ($mapnames[$x], $GUI_HIDE)
							GUICtrlSetState ($mapcoords[$x], $GUI_HIDE)
						ElseIF StringInStr($sectorslabel[$zoom],"-P") > 0 Then
							GUICtrlSetState ($maplabels[$x], $GUI_SHOW)
							GUICtrlSetState ($mapnames[$x], $GUI_SHOW)
							GUICtrlSetState ($mapcoords[$x], $GUI_HIDE)
						ElseIF StringInStr($sectorslabel[$zoom],"-L") > 0 Then
							GUICtrlSetState ($maplabels[$x], $GUI_SHOW)
							GUICtrlSetState ($mapnames[$x], $GUI_HIDE)
							GUICtrlSetState ($mapcoords[$x], $GUI_HIDE)
						Else
							GUICtrlSetState ($maplabels[$x], $GUI_SHOW)
							GUICtrlSetState ($mapnames[$x], $GUI_SHOW)
							GUICtrlSetState ($mapcoords[$x], $GUI_SHOW)
						EndIf
						GUICtrlSetTip($maplabels[$x],GuiCtrlRead($mapnames[$x]) & @CRLF & "(" & $sectorssx[$x] & "," & $sectorssy[$x] & "," & $sectorssz[$x] & ")")
					Else
						GUICtrlSetState ($maplabels[$x], $GUI_HIDE)
						GUICtrlSetState ($mapnames[$x], $GUI_HIDE)
						GUICtrlSetState ($mapcoords[$x], $GUI_HIDE)
					EndIf
				Next
				$displayedmap = True
				If $go = False Then
					$lastoffsetx = $offsetx
					$lastoffsetz = $offsetz
				EndIf
			EndIf
			If $follow = True Then
				$currentx = $currentxx
				$currentz = $currentzz
			Else
				$currentx = $dataarray[12] + ($zoomfactor[$zoom][2] * $offsetx)
				$currentz = $dataarray[14] + ($zoomfactor[$zoom][2] * $offsetz)
			EndIf
;----------
			If ($currentx < $zoomfactor[$zoom][1] * -1) Or ($currentx > $zoomfactor[$zoom][1]) Or ($currentz < $zoomfactor[$zoom][1] * -1) Or ($currentz > $zoomfactor[$zoom][1]) Then
				GUICtrlSetState ($pntr, $GUI_HIDE)
			Else
				$currentx = ($zoomfactor[$zoom][1] + $currentx)
				If $currentx > 0 Then
					$currentx = ($currentx / $zoomfactor[$zoom][3])
					$currentx = Round($currentx, 0)
				EndIf
				$currentz = ($zoomfactor[$zoom][1] - $currentz)
				If $currentz > 0 Then
					$currentz = ($currentz / $zoomfactor[$zoom][3])
					$currentz = Round($currentz, 0)
				EndIf
				$currentx = ($currentx + 297) * $scalex
				$currentz = ($currentz + 147) * $scalez
				$currentx = Ceiling($currentx)
				$currentz = Ceiling($currentz)

				GUICtrlSetPos ($pntr, $currentx, $currentz)
				GUICtrlSetState ($pntr, $GUI_SHOW)
			EndIf

			If $wasgo = True Then
				$currentx = $gox + ($zoomfactor[$zoom][2] * $offsetx)
				$currentz = $goz + ($zoomfactor[$zoom][2] * $offsetz)

				If ($currentx < $zoomfactor[$zoom][1] * -1) Or ($currentx > $zoomfactor[$zoom][1]) Or ($currentz < $zoomfactor[$zoom][1] * -1) Or ($currentz > $zoomfactor[$zoom][1]) Then
					GUICtrlSetState ($gopntr, $GUI_HIDE)
				Else
					$currentx = ($zoomfactor[$zoom][1] + $currentx)
					If $currentx > 0 Then
						$currentx = ($currentx / $zoomfactor[$zoom][3])
						$currentx = Round($currentx, 0)
					EndIf
					$currentz = ($zoomfactor[$zoom][1] - $currentz)
					If $currentz > 0 Then
						$currentz = ($currentz / $zoomfactor[$zoom][3])
						$currentz = Round($currentz, 0)
					EndIf
					$currentx = ($currentx + 298) * $scalex
					$currentz = ($currentz + 145) * $scalez
					$currentx = Ceiling($currentx)
					$currentz = Ceiling($currentz)
					GUICtrlSetPos ($gopntr, $currentx, $currentz)
					GUICtrlSetState ($gopntr, $GUI_SHOW)
				EndIf
			Else
				GUICtrlSetState ($gopntr, $GUI_HIDE)
			EndIf

		Else	; $zoom >= $MAPCHLVL

			If ($offsetx <> $lastoffsetx) OR ($offsetz <> $lastoffsetz) or ($displayedmap = False) Then
				For $x = 1 to $maplist[0]
					GUICtrlSetState ($maplabels[$x], $GUI_HIDE)
					GUICtrlSetState ($mapnames[$x], $GUI_HIDE)
					GUICtrlSetState ($mapcoords[$x], $GUI_HIDE)
				Next
				$currentmapx = ($offsetx * $zoomfactor[$zoom][2]) * -1
				$currentmapz = ($offsetz * $zoomfactor[$zoom][2]) * -1
				GUICtrlSetData($hcurrentmapx, $currentmapx)
				$y = StringLen($currentmapz)
				$array = StringSplit ($currentmapz, "")
				$temp = ""
				For $x =  1 to $array[0]
					$temp = $temp & $array[$x] & @CR
					$currentmapz = $temp
				Next
				If $y < 8 Then
					For $x = 1 to Int(((Iif($array[1] = "-", 8, 7) - $y)) / 2)
						$currentmapz = " " & @CR & $currentmapz
					Next
				EndIf
				GUICtrlSetData($hcurrentmapz, $currentmapz)

				For $x = 1 To $objectlist[0]
					If ($objectssx[$x] + ($zoomfactor[$zoom][2] * $offsetx) <= $zoomfactor[$zoom][1]) and ($objectssx[$x] + ($zoomfactor[$zoom][2] * $offsetx) >= $zoomfactor[$zoom][1] * -1) and ($objectssz[$x] + ($zoomfactor[$zoom][2] * $offsetz) <= $zoomfactor[$zoom][1]) and ($objectssz[$x] + ($zoomfactor[$zoom][2] * $offsetz) >= $zoomfactor[$zoom][1] * -1) Then
						$sx = $objectssx[$x] + ($zoomfactor[$zoom][2] * $offsetx)
						$sz = $objectssz[$x] + ($zoomfactor[$zoom][2] * $offsetz)
						$sx = ($zoomfactor[$zoom][1] + $sx)
						If $sx > 0 Then
							$sx = ($sx / $zoomfactor[$zoom][3])
						EndIf
						$sz = ($zoomfactor[$zoom][1] - $sz)
						If $sz > 0 Then
							$sz = ($sz / $zoomfactor[$zoom][3])
						EndIf

						If $objectsx[$x] <> 0 Then
							$sx = $sx + ($objectsx[$x]/200000/$zoomfactor[$zoom][3]) ; / 8000)
						EndIf
						If $objectsz[$x] <> 0 Then
							$sz = $sz - ($objectsz[$x]/200000/$zoomfactor[$zoom][3]) ; / 8000)
						EndIf

						If $sx > 0 and $sx <= 400 and $sz > 0 and $sz <= 400 Then
							$sx = ($sx + 299) * $scalex
							$sz = ($sz + 148) * $scalez
							$sx = Ceiling($sx)
							$sz = Ceiling($sz)

							GUICtrlSetPos ($objectlabels[$x], $sx, $sz)

							If $objectslabel[$x] = "DOWN" Then
								GUICtrlSetPos ($objectnames[$x], $sx - 12, $sz + 4)
							ElseIf $objectslabel[$x] = "LEFT" Then
								$y = (StringLen($objects[$x]) * 6.2)
								$y = Round($y, 0)
								If $y < 30 Then $y = 30
								GUICtrlSetPos ($objectnames[$x], $sx - $y - 2, $sz - 4)
							ElseIf $objectslabel[$x] = "RIGHT" Then
								GUICtrlSetPos ($objectnames[$x], $sx + 7, $sz - 4)
							Else
								GUICtrlSetPos ($objectnames[$x], $sx - 12, $sz - 14)
							EndIf
							If $zoom < $HideNonSystemLabelsAbove Then
								If $objectstype[$x] = "PLANET" Then
									GUICtrlSetState ($objectlabels[$x], $GUI_SHOW)
									GUICtrlSetState ($objectnames[$x], $GUI_SHOW)
								Else
									GUICtrlSetState ($objectlabels[$x], $GUI_SHOW)
									GUICtrlSetState ($objectnames[$x], $GUI_HIDE)
								EndIf
							Else
								If $objectslabel[$x] = "HIDE" Then
									GUICtrlSetState ($objectlabels[$x], $GUI_SHOW)
									GUICtrlSetState ($objectnames[$x], $GUI_HIDE)
								Else
									GUICtrlSetState ($objectlabels[$x], $GUI_SHOW)
									GUICtrlSetState ($objectnames[$x], $GUI_SHOW)
								EndIf
							EndIf
							GuiCtrlSetTip($objectlabels[$x],$objectstype[$x] & ": " & $objects[$x] & @CR & "SX=" & $objectssx[$x] & ", SY=" & $objectssy[$x] & ", SZ=" & $objectssz[$x] & @CR & "X=" & $objectsx[$x] & ", Y=" & $objectsy[$x] & ", Z=" & $objectsz[$x])

						Else
							GUICtrlSetState ($objectlabels[$x], $GUI_HIDE)
							GUICtrlSetState ($objectnames[$x], $GUI_HIDE)
						EndIf
					Else
						GUICtrlSetState ($objectlabels[$x], $GUI_HIDE)
						GUICtrlSetState ($objectnames[$x], $GUI_HIDE)
					EndIf
				Next
				$displayedmap = True
				If $go = False Then
					$lastoffsetx = $offsetx
					$lastoffsetz = $offsetz
				EndIf
			EndIf
			If $follow = True Then
				$currentx = $currentxx
				$currentz = $currentzz
			Else
				$currentx = $dataarray[12] + ($zoomfactor[$zoom][2] * $offsetx)
				$currentz = $dataarray[14] + ($zoomfactor[$zoom][2] * $offsetz)
			EndIf
;----------
			If ($currentx < $zoomfactor[$zoom][1] * -1) Or ($currentx > $zoomfactor[$zoom][1]) Or ($currentz < $zoomfactor[$zoom][1] * -1) Or ($currentz > $zoomfactor[$zoom][1]) Then
				GUICtrlSetState ($pntr, $GUI_HIDE)
			Else
				$currentx = ($zoomfactor[$zoom][1] + $currentx)
				If $currentx > 0 Then
					$currentx = ($currentx / $zoomfactor[$zoom][3])
					$currentx = Round($currentx, 0)
				EndIf
				$currentz = ($zoomfactor[$zoom][1] - $currentz)
				If $currentz > 0 Then
					$currentz = ($currentz / $zoomfactor[$zoom][3])
					$currentz = Round($currentz, 0)
				EndIf

				If $dataarray[9] <> 0 Then
					$currentx = $currentx + ($dataarray[9]/200000/$zoomfactor[$zoom][3]) ; / 8000)
				EndIf
				If $dataarray[11] <> 0 Then
					$currentz = $currentz - ($dataarray[11]/200000/$zoomfactor[$zoom][3]) ; / 8000)
				EndIf

				$currentx = ($currentx + 297) * $scalex
				$currentz = ($currentz + 147) * $scalez
				$currentx = Ceiling($currentx)
				$currentz = Ceiling($currentz)

				GUICtrlSetPos ($pntr, $currentx, $currentz)
				GUICtrlSetState ($pntr, $GUI_SHOW)
			EndIf

			If $wasgo = True Then
				$currentx = $gox + ($zoomfactor[$zoom][2] * $offsetx)
				$currentz = $goz + ($zoomfactor[$zoom][2] * $offsetz)

				If ($currentx < $zoomfactor[$zoom][1] * -1) Or ($currentx > $zoomfactor[$zoom][1]) Or ($currentz < $zoomfactor[$zoom][1] * -1) Or ($currentz > $zoomfactor[$zoom][1]) Then
					GUICtrlSetState ($gopntr, $GUI_HIDE)
				Else
					$currentx = ($zoomfactor[$zoom][1] + $currentx)
					If $currentx > 0 Then
						$currentx = ($currentx / $zoomfactor[$zoom][3])
						$currentx = Round($currentx, 0)
					EndIf
					$currentz = ($zoomfactor[$zoom][1] - $currentz)
					If $currentz > 0 Then
						$currentz = ($currentz / $zoomfactor[$zoom][3])
						$currentz = Round($currentz, 0)
					EndIf
					$currentx = ($currentx + 298) * $scalex
					$currentz = ($currentz + 145) * $scalez
					$currentx = Ceiling($currentx)
					$currentz = Ceiling($currentz)
					GUICtrlSetPos ($gopntr, $currentx, $currentz)
					GUICtrlSetState ($gopntr, $GUI_SHOW)
				EndIf
			Else
				GUICtrlSetState ($gopntr, $GUI_HIDE)
			EndIf
		EndIf
		_TipDisplayLen(15000)
		$begin = TimerInit()
	EndIf

WEnd

DllClose($hUser32Dll)
$stRET1 = _WinAPI_GetWindowPlacement($handle)
$left1 = DllStructGetData($stRET1, "rcNormalPosition", 1)
$top1 = DllStructGetData($stRET1, "rcNormalPosition", 2)
$stRET1 = _WinAPI_GetWindowPlacement($hnoteswindow)
$left2 = DllStructGetData($stRET1, "rcNormalPosition", 1)
$top2 = DllStructGetData($stRET1, "rcNormalPosition", 2)
$stRET1 = _WinAPI_GetWindowPlacement($hlogwindow)
$left3 = DllStructGetData($stRET1, "rcNormalPosition", 1)
$top3 = DllStructGetData($stRET1, "rcNormalPosition", 2)

If FileExists("EM_Tool.dat") Then FileDelete("EM_Tool.dat")
FileWriteLine("EM_Tool.dat", $left1)
FileWriteLine("EM_Tool.dat", $top1)
FileWriteLine("EM_Tool.dat", $left2)
FileWriteLine("EM_Tool.dat", $top2)
FileWriteLine("EM_Tool.dat", $left3)
FileWriteLine("EM_Tool.dat", $top3)
Exit

Func Level($currentlevel)
	;Graph Levels
	Local $result
	If $currentlevel < 1 Then
		$result = ""
	Else
		$count = int((11 / 100 )* $currentlevel)
		;$result = _StringRepeat("*", $count)
		$result = _StringRepeat(Chrw(0x2588), $count)
	EndIf
	Return $result
EndFunc

Func LoadMap($reload)
	If $reload = True Then
		For $x = 1 to $maplist[0]
			GUICtrlDelete($maplabels[$x])
			GUICtrlDelete($mapnames[$x])
			GUICtrlDelete($mapcoords[$x])
		Next
		For $x = 1 to $objectlist[0]
			GUICtrlDelete($objectlabels[$x])
			GUICtrlDelete($objectnames[$x])
			;GUICtrlDelete($objectcoords[$x])
			;GUICtrlDelete($objectscoords[$x])
		Next
		GUICtrlDelete($pntr)
		GUICtrlDelete($gopntr)
	EndIf
	$sectorcount = 0
	$objectcount = 0
	If FileExists("EM_Tool.txt") Then
		If _FileReadToArray(@WorkingDir & "\" & "EM_Tool.txt", $maplist) Then
			Global $sectors[$maplist[0] + 1]
			Global $sectorssx[$maplist[0] + 1]
			Global $sectorssy[$maplist[0] + 1]
			Global $sectorssz[$maplist[0] + 1]
			Global $sectorzoom1[$maplist[0] + 1]
			Global $sectorzoom2[$maplist[0] + 1]
			Global $sectorzoom3[$maplist[0] + 1]
			Global $sectorzoom4[$maplist[0] + 1]
			Global $sectorzoom5[$maplist[0] + 1]
			Global $sectorzoom6[$maplist[0] + 1]
			Global $sectorzoom7[$maplist[0] + 1]
			Global $maplabels[$maplist[0] + 1], $mapnames[$maplist[0] + 1],$mapcoords[$maplist[0] + 1]
			GUISetFont ( 8, 400, 0, "Arial")
			For $x = 1 to $maplist[0]
				If StringLeft($maplist[$x], 7) = "SECTOR=" Then
					$array = _StringBetween($maplist[$x], "SECTOR=", ",SX=")
					If @error <> 0 Then
						$msgreturn = MsgBox(49, "MAP FILE ERROR", "There is a problem with SECTOR= in line " & $x)
						If $msgreturn = 1 Then
							ContinueLoop
						Else
							Exit
						EndIf
					EndIf
					$sectors[$x] = $array[0]
					$sectorcount = $sectorcount + 1
					$array = _StringBetween($maplist[$x], "SX=", ",SY=")
					If @error <> 0 Then
						$msgreturn = MsgBox(49, "MAP FILE ERROR", "There is a problem with SX= in line " & $x)
						If $msgreturn = 1 Then
							ContinueLoop
						Else
							Exit
						EndIf
					EndIf
					$sectorssx[$x] = $array[0]
					$array = _StringBetween($maplist[$x], "SY=", ",SZ=")
					If @error <> 0 Then
						$msgreturn = MsgBox(49, "MAP FILE ERROR", "There is a problem with SY= in line " & $x)
						If $msgreturn = 1 Then
							ContinueLoop
						Else
							Exit
						EndIf
					EndIf
					$sectorssy[$x] = $array[0]
					$array = _StringBetween($maplist[$x], "SZ=", ",ZOOM1=")
					If @error <> 0 Then
						$msgreturn = MsgBox(49, "MAP FILE ERROR", "There is a problem with SZ= in line " & $x)
						If $msgreturn = 1 Then
							ContinueLoop
						Else
							Exit
						EndIf
					EndIf
					$sectorssz[$x] = $array[0]
					$array = _StringBetween($maplist[$x], "ZOOM1=", ",ZOOM2=")
					If @error <> 0 Then
						$msgreturn = MsgBox(49, "MAP FILE ERROR", "There is a problem with ZOOM1= in line " & $x)
						If $msgreturn = 1 Then
							ContinueLoop
						Else
							Exit
						EndIf
					EndIf
					$sectorzoom1[$x] = $array[0]
					$array = _StringBetween($maplist[$x], "ZOOM2=", ",ZOOM3=")
					If @error <> 0 Then
						$msgreturn = MsgBox(49, "MAP FILE ERROR", "There is a problem with ZOOM2= in line " & $x)
						If $msgreturn = 1 Then
							ContinueLoop
						Else
							Exit
						EndIf
					EndIf
					$sectorzoom2[$x] = $array[0]
					$array = _StringBetween($maplist[$x], "ZOOM3=", ",ZOOM4=")
					If @error <> 0 Then
						$msgreturn = MsgBox(49, "MAP FILE ERROR", "There is a problem with ZOOM3= in line " & $x)
						If $msgreturn = 1 Then
							ContinueLoop
						Else
							Exit
						EndIf
					EndIf
					$sectorzoom3[$x] = $array[0]
					$array = _StringBetween($maplist[$x], "ZOOM4=", ",ZOOM5=")
					If @error <> 0 Then
						$msgreturn = MsgBox(49, "MAP FILE ERROR", "There is a problem with ZOOM4= in line " & $x)
						If $msgreturn = 1 Then
							ContinueLoop
						Else
							Exit
						EndIf
					EndIf
					$sectorzoom4[$x] = $array[0]
					$array = _StringBetween($maplist[$x], "ZOOM5=", ",ZOOM6=")
					If @error <> 0 Then
						$msgreturn = MsgBox(49, "MAP FILE ERROR", "There is a problem with ZOOM5= in line " & $x)
						If $msgreturn = 1 Then
							ContinueLoop
						Else
							Exit
						EndIf
					EndIf
					$sectorzoom5[$x] = $array[0]
					$array = _StringBetween($maplist[$x], "ZOOM6=", ",ZOOM7=")
					If @error <> 0 Then
						$msgreturn = MsgBox(49, "MAP FILE ERROR", "There is a problem with ZOOM6= in line " & $x)
						If $msgreturn = 1 Then
							ContinueLoop
						Else
							Exit
						EndIf
					EndIf
					$sectorzoom6[$x] = $array[0]
					$array = _StringBetween($maplist[$x], "ZOOM7=", "")
					If @error <> 0 Then
						$msgreturn = MsgBox(49, "MAP FILE ERROR", "There is a problem with ZOOM7= in line " & $x)
						If $msgreturn = 1 Then
							ContinueLoop
						Else
							Exit
						EndIf
					EndIf
					$sectorzoom7[$x] = $array[0]

					$maplabels[$x] = GUICtrlCreateLabel(" ", 0, 0, 4,4)
					GUICtrlSetState ($maplabels[$x], $GUI_HIDE)
					GUICtrlSetResizing(-1, $GUI_DOCKSIZE)
					GUICtrlSetColor ($maplabels[$x], "0xFFFF00")
					GUICtrlSetBkColor ($maplabels[$x], "0xFFFF00")

					$y = (StringLen($sectors[$x]) * 6.3)
					$y = Round($y, 0)
					If $y < 30 Then $y = 32
					$mapnames[$x] = GUICtrlCreateLabel($sectors[$x], 10000, 10000, $y,12)
					GUICtrlSetState ($mapnames[$x], $GUI_HIDE)
					GUICtrlSetResizing(-1, $GUI_DOCKSIZE)
					GUICtrlSetColor ($mapnames[$x], "0xFFFFFF")
					GUICtrlSetBkColor ($mapnames[$x], $GUI_BKCOLOR_TRANSPARENT)

					$y = ((StringLen($sectorssx[$x]) + StringLen($sectorssz[$x]) + 2) * 6.3)
					$y = Round($y, 0)
					If $y < 30 Then $y = 32
					$mapcoords[$x] = GUICtrlCreateLabel("(" & $sectorssx[$x] & "," & $sectorssz[$x] & ")", 10000, 10000, $y, 10)
					GUICtrlSetState ($mapcoords[$x], $GUI_HIDE)
					GUICtrlSetResizing(-1, $GUI_DOCKSIZE)
					GUICtrlSetColor ($mapcoords[$x], "0xFFFFFF")
					GUICtrlSetBkColor ($mapcoords[$x], $GUI_BKCOLOR_TRANSPARENT)

				EndIf
			Next
		Else
			MsgBox(16, "ERROR", "Could not open " & @WorkingDir & "\EMToolNotes\" & $thisnotefile & " Error:" & @error)
			Exit
		EndIf
	Else
		MsgBox(16, "ERROR", "Could not find EM_Tool.txt")
		Exit
	EndIf

	If FileExists("EM_Tool2.txt") Then
		If _FileReadToArray(@WorkingDir & "\" & "EM_Tool2.txt", $objectlist) Then
			Global $objects[$objectlist[0] + 1]
			Global $objectstype[$objectlist[0] + 1]
			Global $objectsx[$objectlist[0] + 1]
			Global $objectsy[$objectlist[0] + 1]
			Global $objectsz[$objectlist[0] + 1]
			Global $objectssx[$objectlist[0] + 1]
			Global $objectssy[$objectlist[0] + 1]
			Global $objectssz[$objectlist[0] + 1]
			Global $objectslabel[$objectlist[0] + 1]
			Global $objectlabels[$objectlist[0] + 1], $objectnames[$objectlist[0] + 1];, $objectcoords[$objectlist[0] + 1],$objectscoords[$objectlist[0] + 1]

			GUISetFont ( 8, 400, 0, "Arial")
			For $x = 1 to $objectlist[0]
				If StringLeft($objectlist[$x], 7) = "OBJECT=" Then
					$array = _StringBetween($objectlist[$x], "OBJECT=", ",TYPE=")
					If @error <> 0 Then
						$msgreturn = MsgBox(49, "MAP2 FILE ERROR", "There is a problem with OBJECT= in line " & $x)
						If $msgreturn = 1 Then
							ContinueLoop
						Else
							Exit
						EndIf
					EndIf
					$objects[$x] = $array[0]
					$objectcount = $objectcount + 1
					$array = _StringBetween($objectlist[$x], "TYPE=", ",X=")
					If @error <> 0 Then
						$msgreturn = MsgBox(49, "MAP2 FILE ERROR", "There is a problem with TYPE= in line " & $x)
						If $msgreturn = 1 Then
							ContinueLoop
						Else
							Exit
						EndIf
					EndIf
					$objectstype[$x] = $array[0]
					$array = _StringBetween($objectlist[$x], "X=", ",Y=")
					If @error <> 0 Then
						$msgreturn = MsgBox(49, "MAP2 FILE ERROR", "There is a problem with X= in line " & $x)
						If $msgreturn = 1 Then
							ContinueLoop
						Else
							Exit
						EndIf
					EndIf
					$objectsx[$x] = $array[0]
					$array = _StringBetween($objectlist[$x], "Y=", ",Z=")
					If @error <> 0 Then
						$msgreturn = MsgBox(49, "MAP2 FILE ERROR", "There is a problem with Y= in line " & $x)
						If $msgreturn = 1 Then
							ContinueLoop
						Else
							Exit
						EndIf
					EndIf
					$objectsy[$x] = $array[0]
					$array = _StringBetween($objectlist[$x], "Z=", ",SX=")
					If @error <> 0 Then
						$msgreturn = MsgBox(49, "MAP2 FILE ERROR", "There is a problem with Z= in line " & $x)
						If $msgreturn = 1 Then
							ContinueLoop
						Else
							Exit
						EndIf
					EndIf
					$objectsz[$x] = $array[0]
					$array = _StringBetween($objectlist[$x], "SX=", ",SY=")
					If @error <> 0 Then
						$msgreturn = MsgBox(49, "MAP2 FILE ERROR", "There is a problem with SX= in line " & $x)
						If $msgreturn = 1 Then
							ContinueLoop
						Else
							Exit
						EndIf
					EndIf
					$objectssx[$x] = $array[0]
					$array = _StringBetween($objectlist[$x], "SY=", ",SZ=")
					If @error <> 0 Then
						$msgreturn = MsgBox(49, "MAP2 FILE ERROR", "There is a problem with SY= in line " & $x)
						If $msgreturn = 1 Then
							ContinueLoop
						Else
							Exit
						EndIf
					EndIf
					$objectssy[$x] = $array[0]
					$array = _StringBetween($objectlist[$x], "SZ=", ",LABEL=")
					If @error <> 0 Then
						$msgreturn = MsgBox(49, "MAP2 FILE ERROR", "There is a problem with SZ= in line " & $x)
						If $msgreturn = 1 Then
							ContinueLoop
						Else
							Exit
						EndIf
					EndIf
					$objectssz[$x] = $array[0]
					$array = _StringBetween($objectlist[$x], "LABEL=", "")
					If @error <> 0 Then
						$msgreturn = MsgBox(49, "MAP2 FILE ERROR", "There is a problem with LABEL= in line " & $x)
						If $msgreturn = 1 Then
							ContinueLoop
						Else
							Exit
						EndIf
					EndIf
					$objectslabel[$x] = $array[0]

					$objectlabels[$x] = GUICtrlCreateLabel(" ", 0, 0, 4,4)
					GUICtrlSetState ($objectlabels[$x], $GUI_HIDE)
					GUICtrlSetResizing(-1, $GUI_DOCKSIZE)
					Switch $objectstype[$x]
						Case  "STATION", "CARRIER"
							GUICtrlSetColor ($objectlabels[$x], "0x00FFFF")
							GUICtrlSetBkColor ($objectlabels[$x], "0x00FFFF")
						Case "PLANET"
							GUICtrlSetColor ($objectlabels[$x], "0x00AA00")
							GUICtrlSetBkColor ($objectlabels[$x], "0x00AA00")
						Case "STAR"
							GUICtrlSetColor ($objectlabels[$x], "0xFFFFFF")
							GUICtrlSetBkColor ($objectlabels[$x], "0xFFFFFF")
						Case "BLACK"
							GUICtrlSetColor ($objectlabels[$x], "0xFF0000")
							GUICtrlSetBkColor ($objectlabels[$x], "0xFF0000")
						Case "WORM", "GATE"
							GUICtrlSetColor ($objectlabels[$x], "0xFF00FF")
							GUICtrlSetBkColor ($objectlabels[$x], "0xFF00FF")
						Case "ASTEROID"
							GUICtrlSetColor ($objectlabels[$x], "0x663300")
							GUICtrlSetBkColor ($objectlabels[$x], "0x663300")
						Case "MOON"
							GUICtrlSetColor ($objectlabels[$x], "0x666666")
							GUICtrlSetBkColor ($objectlabels[$x], "0x666666")
						Case "NEBULA"
							GUICtrlSetColor ($objectlabels[$x], "0xFF6600")
							GUICtrlSetBkColor ($objectlabels[$x], "0xFF6600")
						Case Else
							GUICtrlSetColor ($objectlabels[$x], "0xFFFF00")
							GUICtrlSetBkColor ($objectlabels[$x], "0xFFFF00")
					EndSwitch
					$y = (StringLen($objects[$x]) * 6.3)
					$y = Round($y, 0)
					If $y < 30 Then $y = 32
					$objectnames[$x] = GUICtrlCreateLabel($objects[$x], 10000, 10000, $y, 12)
					GUICtrlSetState ($objectnames[$x], $GUI_HIDE)
					GUICtrlSetResizing(-1, $GUI_DOCKSIZE)
					GUICtrlSetColor ($objectnames[$x], "0xFFFFFF")
					GUICtrlSetBkColor ($objectnames[$x], $GUI_BKCOLOR_TRANSPARENT)
				EndIf
			Next
		Else
			MsgBox(16, "ERROR", "Could not open " & @WorkingDir & "\EMToolNotes\" & $thisnotefile & " Error:" & @error)
			Exit
		EndIf
	Else
		MsgBox(16, "ERROR", "Could not find EM_Tool.txt")
		Exit
	EndIf

	GUISetFont (4, 800, 0, "Arial")
	Global $pntr = GUICtrlCreateLabel(" ", 496, 346, 8,8)
	GUICtrlSetResizing(-1, $GUI_DOCKSIZE)
	GUICtrlSetColor ($pntr, "0x00FF00")
	GUICtrlSetBkColor ($pntr, "0x00FF00")

	GUISetFont (8, 800, 0, "Arial")
	Global $gopntr = GUICtrlCreateLabel("X", 496, 346, 12,12)
	GUICtrlSetResizing(-1, $GUI_DOCKSIZE)
	GUICtrlSetColor ($gopntr, "0xFF0000")
	GUICtrlSetBkColor ($gopntr, $GUI_BKCOLOR_TRANSPARENT)
	GUICtrlSetState ($gopntr, $GUI_HIDE)

EndFunc

Func HotKeyPressed()
	Switch @HotKeyPressed
		Case "{F1}"
			$zoom = 1
		Case "{F2}"
			$zoom = 2
		Case "{F3}"
			$zoom = 3
		Case "{F4}"
			$zoom = 4
		Case "{F5}"
			$zoom = 5
		Case "{F6}"
			$zoom = 6
		Case "{F7}"
			$zoom = 7
		Case "{F8}"
			$zoom = 8
		Case "{F9}"
			$zoom = 9
		Case "{F10}"
			$zoom = 10
		Case "{F11}"
			$zoom = 11
		Case "{F12}"
			$zoom = 12
	EndSwitch
	$displayedmap = False
	GUICtrlSetData($hzoom, $zoom)
	GUICtrlSetData($hscale, $zoomfactor[$zoom][2])
	$zoomed = True
	Return
EndFunc
Func SetHotKeys()
	HotKeySet ( "{F1}" , "HotKeyPressed")
	HotKeySet ( "{F2}" , "HotKeyPressed")
	HotKeySet ( "{F3}" , "HotKeyPressed")
	HotKeySet ( "{F4}" , "HotKeyPressed")
	HotKeySet ( "{F5}" , "HotKeyPressed")
	HotKeySet ( "{F6}" , "HotKeyPressed")
	HotKeySet ( "{F7}" , "HotKeyPressed")
	HotKeySet ( "{F8}" , "HotKeyPressed")
	HotKeySet ( "{F9}" , "HotKeyPressed")
	HotKeySet ( "{F10}" , "HotKeyPressed")
	HotKeySet ( "{F11}" , "HotKeyPressed")
	HotKeySet ( "{F12}" , "HotKeyPressed")
	HotKeySet ( "^{`}" , "HotKeyMapInfoPressed")
	HotKeySet("{Enter}","EnterPressed")
	HotKeySet("{Esc}","EscapeTextBox")
	ConditionalKeys(True)
	Return
EndFunc
Func ConditionalKeys($flg)
	If $flg = True Then
		HotKeySet("{UP}","MoveMapKeyPressed")
		HotKeySet("{DOWN}","MoveMapKeyPressed")
		HotKeySet("{LEFT}","MoveMapKeyPressed")
		HotKeySet("{RIGHT}","MoveMapKeyPressed")
		HotKeySet("{=}","MoveMapKeyPressed")
		HotKeySet("{-}","MoveMapKeyPressed")
		HotKeySet("{f}","MoveMapKeyPressed")
		HotKeySet("{s}","MoveMapKeyPressed")
		HotKeySet("{x}","MoveMapKeyPressed")
		HotKeySet("{n}","MoveMapKeyPressed")
		HotKeySet("{l}","MoveMapKeyPressed")
	Else
		HotKeySet("{UP}")
		HotKeySet("{DOWN}")
		HotKeySet("{LEFT}")
		HotKeySet("{RIGHT}")
		HotKeySet("{=}")
		HotKeySet("{-}")
		HotKeySet("{f}")
		HotKeySet("{s}")
		HotKeySet("{x}")
		HotKeySet("{n}")
		HotKeySet("{l}")
	EndIf
EndFunc
Func UnSetHotKeys()
	HotKeySet ( "{F1}" )
	HotKeySet ( "{F2}" )
	HotKeySet ( "{F3}" )
	HotKeySet ( "{F4}" )
	HotKeySet ( "{F5}" )
	HotKeySet ( "{F6}" )
	HotKeySet ( "{F7}" )
	HotKeySet ( "{F8}" )
	HotKeySet ( "{F9}" )
	HotKeySet ( "{F10}" )
	HotKeySet ( "{F11}" )
	HotKeySet ( "{F12}" )
	HotKeySet ( "{Enter}" )
	HotKeySet ( "{Esc}" )
	HotKeySet ( "^{`}" )
	ConditionalKeys(False)
	Return
EndFunc
Func Logit($logentry)
	$logtime = @MDAY & "/" & @MON & "/" & @YEAR & " - " & @HOUR & ":" & @MIN & ":" & @SEC
	FileWriteLine("EM_Tool.log", $logtime & "-: " & $logentry)
	GUICtrlSetData($hlogedit, GUICtrlRead($hlogedit) & @CRLF & $logtime & " -: " & $logentry)
EndFunc
Func On_WM_ACTIVATE($hWnd, $Msg, $wParam, $lParam)
    Local $iState = BitAnd($wParam, 0x0000FFFF), $iMinimize = BitShift($wParam, 16)
    If $iState Then
        SetHotKeys()
    Else
        UnSetHotKeys()
    EndIf
EndFunc
Func Iif($cond , $ret , $ret2 = "")
    If $cond Then Return $ret
    Return $ret2
EndFunc
Func HotKeyMapInfoPressed()
	MsgBox(64, "EM Tool Stats", "Mapped Sectors: " & $sectorcount & @CR & "Mapped Objects: " & $objectcount, 20)
EndFunc

Func MoveMapKeyPressed()
	If	_WinAPI_GetFocus() = ControlGetHandle($handle,"",$hinputs) or _WinAPI_GetFocus() = ControlGetHandle($handle,"",$hinputx) or _WinAPI_GetFocus() = ControlGetHandle($handle,"",$hinputz) then
		ConditionalKeys(False)
		Send(@HotKeyPressed)
		ConditionalKeys(True)
	Else
		Switch @HotKeyPressed
			Case "{UP}"
				ControlClick($handle,"",$hpanup)
			Case "{DOWN}"
				ControlClick($handle,"",$hpandown)
			Case "{LEFT}"
				ControlClick($handle,"",$hpanleft)
			Case "{RIGHT}"
				ControlClick($handle,"",$hpanright)
			Case "{=}"
				ControlClick($handle,"",$hzoomin)
			Case "{-}"
				ControlClick($handle,"",$hzoomout)
			Case "{f}"
				ControlClick($handle,"",$hfollow)
			Case "{s}"
				ControlClick($handle,"",$hinputs)
			Case "{x}"
				ControlClick($handle,"",$hinputx)
			Case "{n}"
				ControlClick($handle,"",$hnotebutton)
			Case "{l}"
				ControlClick($handle,"",$hlogbutton)
		EndSwitch
	EndIf
	Return
EndFunc
Func EnterPressed()
	If	_WinAPI_GetFocus() = ControlGetHandle($handle,"",$hinputs) and GUICtrlRead($hinputs) <> "" Then
		ControlClick($handle,"",$hsearch)
	ElseIf _WinAPI_GetFocus() = ControlGetHandle($handle,"",$hinputx) and GUICtrlRead($hinputx) <> "" Then
		If GUICtrlRead($hinputz) <> "" Then
			ControlClick($handle,"",$hgoto)
		Else
			ControlClick($handle,"",$hinputz)
		EndIf
	ElseIf _WinAPI_GetFocus() = ControlGetHandle($handle,"",$hinputz) and GUICtrlRead($hinputz) <> "" Then
		If GUICtrlRead($hinputx) <> "" Then
			ControlClick($handle,"",$hgoto)
		Else
			ControlClick($handle,"",$hinputx)
		EndIf
	Else
		ControlFocus($handle,"",$hfollow)
	EndIf
	Return
EndFunc
Func EscapeTextBox()
	ControlFocus($handle,"",$hfollow)
	;msgbox(1,"",$perspectivex & "," & $perspectivez)
	Return
EndFunc
Func _TipDisplayLen($time=5000)
    Local $tiphandles, $i
    $tiphandles=WinList('[CLASS:tooltips_class32]')
    for $i=1 to $tiphandles[0][0]
        If WinGetProcess($tiphandles[$i][1]) = @AutoItPID Then _SendMessage($tiphandles[$i][1],0x0403,2,$time)
    Next
EndFunc

Func MAP_WM_COMMAND($hWnd, $Msg, $wParam, $lParam)
	Local Const $STN_DBLCLK = 1
	Local $nNotifyCode = BitShift($wParam, 16)
	Local $nID = BitAnd($wParam, 0x0000FFFF)
	If $zoom >= $MAPCHLVL Then
		For $x = 1 to $objectlist[0]
			If $nID = $objectlabels[$x] Then ;and $msg <> 0 Then
				Switch $nNotifyCode
					Case $BN_CLICKED
						GUICtrlSetData($hinputs,"")
						GUICtrlSetData($hinputx,$objectssx[$x])
						GUICtrlSetData($hinputz,$objectssz[$x])
						$perspectivex = $objectssx + $objectsx/200000
						$perspectivez = $objectssz + $objectsz/200000
						ControlFocus($handle,"",$hfollow)
						Return $GUI_RUNDEFMSG
				EndSwitch
			EndIf
		Next
	ElseIf $zoom < $MAPCHLVL Then
		If $notesopen <> True Then
			For $x = 1 to $maplist[0]
				If $nID = $maplabels[$x] Then ;and $msg <> 0 Then
					Switch $nNotifyCode
						Case $BN_CLICKED
;							set data for input boxes
							GUICtrlSetData($hinputs,$sectors[$x])
							GUICtrlSetData($hinputx,$sectorssx[$x])
							GUICtrlSetData($hinputz,$sectorssz[$x])
							$perspectivex = $sectorssx
							$perspectivez = $sectorssz
							ControlFocus($handle,"",$hfollow)
							Return $GUI_RUNDEFMSG
						Case $STN_DBLCLK
							$MapDblClkFlg = $x
							Return $GUI_RUNDEFMSG
					EndSwitch
				EndIf
			Next
		EndIf
	EndIf
	Return $GUI_RUNDEFMSG
EndFunc
Func WheelMsg($hWndGui, $MsgId, $WParam, $LParam)
	If $MsgId = $WM_MOUSEWHEEL and $displayedmap = True Then
		$Delta = BitShift($WParam, 16)
		$KeysHeld = BitAND($WParam, 0xFFFF)
		$X = BitShift($LParam, 16)
		$Y = BitAND($LParam, 0xFFFF)
		If $Delta > 0 Then
				ControlClick($handle,"",$hzoomin)
		ElseIf $Delta < 0 Then
				ControlClick($handle,"",$hzoomout)
		EndIf
	EndIf
	Return $GUI_RUNDEFMSG
EndFunc
Func doNotes($x)
	$thisnotefile = "EM_Tool_Notes_" & $sectorssx[$x] & "_" & $sectorssy[$x] & "_" & $sectorssz[$x] & ".txt"
	GUICtrlSetData($hnotetitle, $thisnotefile)
	If $thisnotefile <> $currentnotefile Then
		GUICtrlSetData($hnotewarn, "Note: You are not in this sector")
	Else
		GUICtrlSetData($hnotewarn, "")
	EndIf
	If FileExists(@WorkingDir & "\EMToolNotes\" & $thisnotefile) Then
		If _FileReadToArray(@WorkingDir & "\EMToolNotes\" & $thisnotefile, $notes) Then
			For $x = 1 to $notes[0]
				GUICtrlSetData($hedit, GUICtrlRead($hedit) & $notes[$x] & @CRLF)
				GUISetState(@SW_SHOW, $hnoteswindow)
			Next
			GUICtrlSetData($hedit, StringReplace(GUICtrlRead($hedit), _StringRepeat("-", 32), _StringRepeat(Chrw(0x2500), 32)))
		Else
			If @error <> 2 Then
				MsgBox(16, "ERROR", "Could not open " & @WorkingDir & "\EMToolNotes\" & $thisnotefile)
			EndIf
			GUISetState(@SW_SHOW, $hnoteswindow)
			GUICtrlSetData($hedit, $sectors[$x] & @CRLF & _StringRepeat(Chrw(0x2500), 32) & @CRLF)
		EndIf
	Else
		GUISetState(@SW_SHOW, $hnoteswindow)
		GUICtrlSetData($hedit, $sectors[$x] & @CRLF & _StringRepeat(Chrw(0x2500), 32) & @CRLF)
	EndIf
	$notesopen = True
EndFunc
